;*****************************************************************
;*****************************************************************
;                           AI_DEMO.ASM
;*****************************************************************
;*****************************************************************
;
; Tutorial demonstration of the XGA/8514-A Adapter Interface
; functions (see Chapter 6)
;
;*****************************************************************
;                            EXTERNALS
;*****************************************************************
EXTRN   KBR_WAIT:       FAR
EXTRN   OPEN_FILE:      FAR
EXTRN   READ_128:       FAR
EXTRN   CLOSE_FILE:     FAR
EXTRN   SET_DTA:        FAR
;
INCLUDELIB      SOLUTION
;****************************************************************
;                          stack segment
;****************************************************************
STACK   SEGMENT stack

                DB      0400H DUP ('?'); Default stack is 1K
STACK_TOP       EQU     THIS BYTE
;
STACK   ENDS
;
;****************************************************************
;                          data segment
;****************************************************************
DATA    SEGMENT
;**********************|
;  AI state buffer     |
;**********************|
STATE_BUF       DB      360 DUP (00H)
;**********************|
;   AI list address    |
;**********************|
AI_ADD          DD      0       ; Doubleword storage for address
                                ; of Adapter Interface services
;
HQDPS_DATA      DW      6       ; Length of data block
BUF_SIZE        DW      0       ; Buffer size
STK_SIZE        DW      0       ; Stack usage, in bytes
PAL_SIZE        DW      0       ; Palette buffer size, in bytes
;
HOPEN_DATA      DW      3       ; Length of data block
INIT_FLAGS      DB      0       ; 7 6 5 4 3 2 1 0 <= flags
                                ; | | ___________
                                ; | |      |_______ Reserved
                                ; | |_ Don't load default palette
                                ; |___ Don't clear bit planes
AF_MODE         DB      0       ; Advanced function mode
                                ; No.   Pixels     Text
                                ; 00    1024x768   85x38
                                ; 01    640x480    80x34
                                ; 02    1024x768   128x54
                                ; 03    1024x768   146x51
RET_FLAGS       DB      0       ; Status
                                ; 0 if initialization successful
                                ; Not 0 if initialization failed
;
HINIT_DATA      DW      2       ; Length of data block
BUF_SEG         DW      0       ; Segment of AI buffer
;
HCLOSE_DATA     DW      0       ; Length field is zero for HCLOSE
HEGS_DATA       DW      0       ; Length field is zero for HEGS
DUMMY           DW      0       ; Dummy data area
;
;**********************|
;       colors         |
;**********************|
HSCOL_DATA      DW      4       ; Length of data block
FORE_COL        DB      0F0H    ; 8-bit color code
                DB      0       ; Padding for double word
                DW      0
;
HSBCOL_DATA     DW      4       ; Length of data block
BACK_COL        DB      11110000B       ; Bright red in 2-bit
                                        ; IRGB format
                DB      0       ; Padding for double word
                DW      0
;
;***********************|
;       DEBUGGING       |
;***********************|
HQMODE_DATA     DW      18      ; Length of data block
BUG_MODE        DW      0
                DB      18 DUP (00H)
;
;**********************|
; text operations data |
;**********************|
HSCS_DATA       DW      4       ; Length of data block
FONT_OFF        DW      0       ; Offset of loaded font
FONT_SEG        DW      0       ; Segment of loaded font
;
HSMODE_DATA     DW      1       ; Length of data block
MODE_NUMBER     DB      0       ; Mode
;
HCCHST_DATA_1   DW      50      ; Length of data block
                DB      'XGA/8514-a Adapter Interface'
                DB      ' Demonstration Program'
                DW      0
;**********************|
;   alphanumeric data  |
;**********************|
; ASCUR (set cursor shape)
ASCUR_DATA      DW      3       ; Length of data block
                DB      16      ; Cursor start line
                DB      19      ; Cursor stop line
;
CUR_SHAPE       DB      00      ; Cursor attribute:
                                ; 00 = normal
                                ; 01 = hidden
                                ; 02 = left arrow
                                ; 03 = right arrow
; ACURSOR (set cursor position)
ACURSOR_DATA    DW      2       ; Length of data block
CUR_COLUMN      DB      0       ; Cursor column
CUR_ROW         DB      0       ; Cursor row
;
; ASFONT (select character set)
ASFONT_DATA     DW      6       ; Length of data block
                DB      0       ; Font number
                DB      0       ; Reserved
AFONT_OFF       DW      0       ; Offset of loaded font
AFONT_SEG       DW      0       ; Segment of loaded font
;
; ABLOCKCGA (writes a block of characters in CGA emulation mode)
ABLOCKCGA_DATA  DW      10      ; Length of data block
COL_START       DB      0       ; Start column for display
ROW_START       DB      0       ; Start row for display
CHAR_WIDE       DB      0       ; Width of block (characters)
CHAR_HIGH       DB      0       ; Height of block (characters)
STRING_OFF      DW      0       ; Offset of string address
STRING_SEG      DW      0       ; Segment of string address
BUF_WIDE        DB      85      ; Characters per row displayed
ATTRIBUTE       DB      0       ; 7 6 5 4 3 2 1 0 <= BITS
                                ; | | | | | | | |
                                ; | | | | | | |_|__ font (0 to 3)
                                ; | | | | |_|______ reserved
                                ; | | | |__________ 1 = transparent
                                ; | | |             0 = opaque
                                ; | | |____________ overstrike
                                ; | |______________ reverse video
                                ; |________________ underscore
;
;                            __________ background color
;                            |    _____ foreground color
;                            |   |
; String for ABLOCKCGA   C  |--||--|
STRING_1        DB      'T',00001001B
                DB      'h',00001001B
                DB      'i',00001001B
                DB      's',00001001B
                DB      ' ',00001001B
                DB      'i',00001100B
                DB      's',00001100B
                DB      ' ',00001100B
                DB      'a',00001010B
                DB      ' ',00001010B
                DB      't',00011100B
                DB      'e',00011100B
                DB      's',00011100B
                DB      't',00011100B
;
;**********************|
;       markers        |
;**********************|
; HSMARK = define marker symbol
HSMARK_DATA     DW      14      ; Length of data block
MARK_WIDE       DB      8       ; Pixel width of marker symbol
MARK_HIGH       DB      16      ; pixel height of marker
MARK_TYPE       DB      0       ; 7 6 5 4 3 2 1 0 <= BITS
                                ; | |_|_|_|_|_|_|_ reserved (0)
                                ; |____________ 0 = monochrome
                                ;               1 = multicolor
                DB      0       ; Reserved
MARK_SIZE       DW      16      ; Number of bytes in marker image
                                ; size = ((width * height)+7)/8
MARK_OFF        DW      0       ; Offset of marker image map
MARK_SEG        DW      0       ; Segment of marker image map
M_COLOR_OFF     DW      0       ; Offset of color image map
M_COLOR_SEG     DW      0       ; Segment of color image map
;
; Bit map for marker image
MARK_MAP        DB      00100100B       ; 1
                DB      00111100B       ; 2
                DB      00111100B       ; 3
                DB      00111100B       ; 4
                DB      00011000B       ; 5
                DB      00011000B       ; 6
                DB      00011000B       ; 7
                DB      00011000B       ; 8
                DB      00011000B       ; 9
                DB      00011000B       ; 10
                DB      00011000B       ; 11
                DB      11111111B       ; 12
                DB      01111110B       ; 13
                DB      00111100B       ; 14
                DB      00011000B       ; 15
                DB      00011000B       ; 16
;
; Marker display command
HMRK_DATA       DW      8       ; Length of data block
MARKER_X0       DW      40      ; x coordinate of first marker
MARKER_Y0       DW      500     ; y coordinate of first marker
MARKER_X1       DW      55      ; x coordinate of second marker
MARKER_Y1       DW      500     ; y coordinate of second marker
;
;**********************|
;      fonts           |
;**********************|
; ASCIIZ filename for XGA 85-by-38 font
F1220_NAME      DB      'STAN1220.FNT',00H
FONT_HANDLE     DW      0       ; Handle for font file
;
;**********************|
;   storage for font   |
;**********************|
; Font header area
FONT_BUF        DW      0       ; Number of code pages
                DW      0       ; Default code page (0 to 4)
                DW      0       ; Alternate default (0 to 4)
                DD      0       ; 4-byte ID string ('437',0)
PAGE_1_OFFSET   DW      0       ; Offset of CSD within file
                DD      0       ; 4-byte ID string ('850',0)
                DW      0       ; Offset of CSD within file
                DD      0       ; 4-byte ID string ('860',0)
                DW      0       ; Offset of CSD within file
                DD      0       ; 4-byte ID string ('863',0)
                DW      0       ; Offset of CSD within file
                DD      0       ; 4-byte ID string ('865',0)
                DW      0       ; Offset of CSD within file
;
; Character set definition block for first code page
                DB      0       ; Reserved
                DB      0       ; Font type:
                                ; 0 = multi-plane image
                                ; 3 = short vector font
                DB      0       ; Reserved
                DD      0       ; Reserved
CELL_WIDTH      DB      0       ; Pixel width of character cell
CELL_HEIGHT     DB      0       ; Pixel height of cell
                DB      0       ; Reserved
                DW      0       ; Cell size
CSD_FLAGS       DW      0       ; Flag bits:
                                ; Bit 14 ... 0 = single plane
                                ;            1 = multi-plane
                                ;     13 ... 0 = not prop. space
                                ;            1 = prop. space
IDX_TABLE_O     DW      0       ; Offset of index table
IDX_TABLE_S     DW      0       ; Segment of index table
                DW      0       ; Offset of envelope table
                DW      0       ; Segment of envelope table
                DB      0       ; Initial code point
                DB      0       ; Final code point
CSD_TABLE_O     DW      0       ; Offset of character definition
CSD_TABLE_S     DW      0       ; Segment of character definition
                DB      14250 DUP (00H)
;
DATA_BUF        DB      129 DUP (00H)   ; Storage for disk data
;
;
;**********************|
;  line and polygon    |
;   drawing data       |
;**********************|
; HLINE (polyline at given position)
HLINE_DATA      DW      18      ; Length of data block
                DW      500     ; x coordinate of first point
                DW      300     ; y coordinate of first point
                DW      600     ; next x coordinate
                DW      300     ; next y coordinate
                DW      600     ; x
                DW      350     ; y
                DW      700     ; x
                DW      350     ; y
                DW      700     ; x
                DW      200     ; y
;
; Data block for rectangle draw
HRECT_DATA      DW      8       ; Length of data block
RECT_X          DW      0       ; x coordinate of top-left corner
RECT_Y          DW      0       ; y coordinate of top-left corner
RECT_WIDTH      DW      0       ; Width (1 to 1024)
RECT_HIGH       DW      0       ; Height (1 to 768)
;
; Data block to set coordinates of current position
HSCP_DATA       DW      4       ; Length of data block
NEW_X           DW      0       ; New x for current point
NEW_Y           DW      0       ; New y for current point
;
; Draw connected straight line segments to from a polygon
HCLINE_DATA     DW      26      ; Length of data block
                                ; for 12 coordinate points
X0              DW      562     ; x coordinate of first end point
Y0              DW      384     ; y coordinate of first end point
X1              DW      700     ; next x
Y1              DW      500     ; next y
X2              DW      520     ; next x
Y2              DW      550     ; next y
X3              DW      400     ; next x
Y3              DW      500     ; next y
X4              DW      450     ; next x
Y4              DW      384     ; next y
X5              DW      530
Y5              DW      450
                DW      562
                DW      384
;
; Fill area defined after HBAR function
HEAR_DATA       DW      1       ; Length of data block
FILL_MODE       DB      0       ; 7 6 5 4 3 2 1 0 <= Bits
                                ; | | ___________
                                ; | |      |_____ Unused
                                ; |_|__ Fill operation control
                                ; 0 0 = Fill defined area
                                ; 0 1 = Suspend area definition
                                ; 1 0 = Abort area definition
;
;
DATA    ENDS
;
;****************************************************************
;                          code segment
;****************************************************************
;
CODE    SEGMENT
        ASSUME  CS:CODE
;
START:
;*******************|
;  initialization   |
;*******************|
; Establish data and extra segment addressability
        MOV     AX,DATA         ; Address of DATA to AX
        MOV     DS,AX           ; and to DS
        ASSUME  DS:DATA         ; Assume from here on
;**********************|
;  get adapter address |
;**********************|
; The local procedure AI_VECTOR obtains the segment:offset
; address of the adapter handler
        CALL    AI_VECTOR       ; Local procedure
        JNC     OK_VECTOR       ; Go if no carry
; Error exit
AI_ERROR:
        JMP     DOS_EXIT
OK_VECTOR:
; Store segment and offset of AI handler
        MOV     WORD PTR AI_ADD,DX      ; Store offset of address
        MOV     WORD PTR AI_ADD+2,CX    ; and segment
; Entry point is stored in a DS variable
;**********************|
;    initialize AI     |
;**********************|
; Call HQDPS service (query drawing process state)
        MOV     AX,31           ; Code number for this service
        LEA     BX,HQDPS_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; Test task buffer size
        INT     03H
        MOV     AX,BUF_SIZE
        MOV     BX,STK_SIZE
        MOV     CX,PAL_SIZE
;
; Call HOPEN service (enable adapter)
        MOV     INIT_FLAGS,0    ; Set initialization flags
                                ; to clear memory and load default
                                ; palette
        MOV     AF_MODE,0       ; Set 1024x768 mode number 0
        MOV     AX,8            ; Code number for this service
        LEA     BX,HOPEN_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
        MOV     AL,RET_FLAGS    ; Not zero if open error
        CMP     AL,0            ; Test for no error
        JZ      OK_OPEN         ; Go if no error
        JMP     AI_ERROR        ; Error exit
;
; Call HINIT (Initialize adapter state)
OK_OPEN:
        PUSH    DS              ; Data segment
        POP     AX              ; to  AX
        MOV     BUF_SEG,AX      ; Store segment of adapter state
                                ; buffer
        MOV     AX,48           ; Code number for this service
        LEA     BX,HINIT_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
; Call HSCOL (set color)
; HSCOL
        MOV     FORE_COL,0      ; Black
        MOV     AX,7            ; Code number for this service
        LEA     BX,HSCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
; Fill screen using rectangle draw function HRECT
        MOV     RECT_X,0        ; x origin
        MOV     RECT_Y,0        ; y origin
        MOV     RECT_WIDTH,1024 ; width
        MOV     RECT_HIGH,768   ; high
        MOV     AX,32           ; Code number for this service
        LEA     BX,HRECT_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
;**********************|
;    load font file    |
;**********************|
; Before using text display operations one of the four font files
; provided with the adapter must be loaded into RAM
        LEA     DX,F1220_NAME   ; Filename for XGA 12x20 font
        LEA     DI,FONT_BUF     ; Buffer for storing font
        CALL    XGA_FONT        ; Local procedure to load font
; Carry set if error during font load
        JNC     OK_XGA_FONT     ; Go if no error
        JMP     AI_ERROR        ; Error exit
;
;**********************|
; select character set |
;**********************|
; The AI is informed of the address of the loaded font by means
; of the HSCS (set character set) function
OK_XGA_FONT:
        PUSH    DS              ; DS to stack
        POP     AX              ; and to AX
        MOV     FONT_SEG,AX     ; Store segment address
        MOV     AFONT_SEG,AX    ; For alphanumeric operations
; The offset of the font's character set definition block is
; located at byte 10 of the font header
        LEA     SI,FONT_BUF     ; Offset of font buffer
        MOV     BX,[SI+10]      ; Get offset of first code page
        ADD     BX,SI           ; Add offset to pointer
        MOV     FONT_OFF,BX     ; Store pointer in block
        MOV     AFONT_OFF,BX    ; For alphanumeric operations
;**********************|
; update font pointers |
;**********************|
; Update pointers in character set definition area by adding
; the load address of the font (in SI)
        ADD     IDX_TABLE_O,SI  ; Add to index table offset
        ADD     CSD_TABLE_O,SI  ; and to CSD table offset
; AX still holds the segment address. Store segment portion of
; address
        MOV     IDX_TABLE_S,AX  ; In index table
        MOV     CSD_TABLE_S,AX  ; In character set table
;
; Call HSCS (set character set) function
        MOV     AX,37           ; Code number for this service
        LEA     BX,HSCS_DATA    ; Pointer to data block
        CALL    AI_SERVICE
;
;**********************|
;     text display     |
;       exercise       |
;**********************|
; AI text command that start with the prefix letter H are used to
; perform text display operations at the pixel level
; First set current color to bright red
        MOV     FORE_COL,00001100B      ; Bright red
        MOV     AX,7            ; Code number for this service
        LEA     BX,HSCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; Display a text message using the AI text commands
; Mode number 0 (85 columns by 35 rows) was set during HOPEN
; First set current position to top-center of the screen using
; the HSCP (set current position) function
        MOV     NEW_X,200       ; Screen column
; Add row width to top of screen address to obtain bottom of
; first screen line
        MOV     NEW_Y,0         ; Top screen row
        MOV     AL,CELL_HEIGHT  ; From CSD block data
        MOV     AH,0            ; Clear high byte for addition
        ADD     NEW_Y,AX        ; Add to top row
; Call HSCP
        MOV     AX,4            ; Code number for this service
        LEA     BX,HSCP_DATA    ; Pointer to data block
        CALL    AI_SERVICE
; Call HCCHST (display character string at current position)
        MOV     AX,39           ; Code number for this service
        LEA     BX,HCCHST_DATA_1        ; Pointer to data block
        CALL    AI_SERVICE
;
;**********************|
;  alphanumeric text   |
;**********************|
; AI command that start with the prefix letter A are used to
; perform alphanumeric operations at the character cell level
; The size of the character cell is determined by the current
; mode (now set to mode 0, 85 cells per row in 38 rows)
; The alphanumeric commands allow controlling the attribute of
; each individual character displayed
;**********************|
;   cursor exercises   |
;**********************|
; Display cursor
        MOV     CUR_COLUMN,30   ; Column number
        MOV     CUR_ROW,4       ; Row number
;
; Call ASCUR (set cursor shape)
        MOV     AX,45           ; Code number for this service
        LEA     BX,ASCUR_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; CAll ACURSOR (set cursor position)
        MOV     AX,44           ; Code number for this service
        LEA     BX,ACURSOR_DATA ; Pointer to data block
        CALL    AI_SERVICE
;
; Call ASFONT (select font)
        MOV     AX,46           ; Code number for this service
        LEA     BX,ASFONT_DATA  ; Pointer to data block
        CALL    AI_SERVICE
; Display text message using ABLOCKCGA function
; Set display parameters in control block variables
        MOV     COL_START,20    ; Start at column 20
        MOV     ROW_START,30    ; and at row number 30
        MOV     CHAR_WIDE,14    ; Characters wide
        MOV     CHAR_HIGH,1     ; Characters high
        PUSH    DS              ; Data segment
        POP     STRING_SEG      ; Store in variable
        LEA     SI,STRING_1     ; Offset of text string
        MOV     STRING_OFF,SI   ; Store offset of string
; Call ABLOCKCGA
        MOV     AX,41           ; Code number for this service
        LEA     BX,ABLOCKCGA_DATA       ; Pointer to data block
        CALL    AI_SERVICE
;
;**********************|
;   marker exercises   |
;**********************|
; Display monochrome marker (down arrow) stored at MARK_MAP
; Call HSMARK (define marker)
; Set address marker bit map in control block variables
        PUSH    DS              ; Data segment
        POP     MARK_SEG        ; Store in variable
        LEA     SI,MARK_MAP     ; Offset of marker bit map
        MOV     MARK_OFF,SI     ; Store offset of bit map
; Call HSMARK
        MOV     AX,52           ; Code number for this service
        LEA     BX,HSMARK_DATA  ; Pointer to data block
        CALL    AI_SERVICE
; Call HMRK (display markers)
        MOV     AX,50           ; Code number for this service
        LEA     BX,HMRK_DATA    ; Pointer to data block
        CALL    AI_SERVICE
;
;**********************|
;     draw polyline    |
;**********************|
POLYGON:
; Call HSCOL (set color)
        MOV     FORE_COL,00001001B      ; Bright blue
        MOV     AX,7            ; Code number for this service
        LEA     BX,HSCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; Use the HLINE (polyline at given position) to draw a polyline
        MOV     AX,0            ; Code number for this service
        LEA     BX,HLINE_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
        CALL    KBR_WAIT
;
;**********************|
;     draw and fill    |
;       polygon        |
;**********************|
; Call HSCOL (set color)
        MOV     FORE_COL,00001111B      ; Bright white
        MOV     AX,7            ; Code number for this service
        LEA     BX,HSCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; Set background color
        MOV     BACK_COL,11110000B      ; Bright red
        MOV     AX,10           ; Code number for this service
        LEA     BX,HSBCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
;
; Call HSCP (set current coordinate position)
; Coordinates are set at the center of the screen on 1024 by 768
; pixels modes
        MOV     NEW_X,512       ; Middle of screen column
        MOV     NEW_Y,384       ; Middle of screen row
        MOV     AX,4            ; Code number for this service
        LEA     BX,HSCP_DATA    ; Pointer to data block
        CALL    AI_SERVICE
;
; Call HBAR to begin fill area
        MOV     AX,5            ; Code number for this service
        LEA     BX,DUMMY        ; Pointer to data block
        CALL    AI_SERVICE
;
; Call HCLINE (draw line at current coordinate position)
; Coordinates of the line's start point were set by the HSCP
; service. Coordinates of polygon points already in data block
        MOV     AX,1            ; Code number for this service
        LEA     BX,HCLINE_DATA  ; Pointer to data block
        CALL    AI_SERVICE
;
; Call HEAR to fill area
        MOV     AX,6            ; Code number for this service
        LEA     BX,HEAR_DATA    ; Pointer to data block
        CALL    AI_SERVICE
;**********************|
;         WAIT         |
;**********************|
        CALL    KBR_WAIT        ; Procedure in SOLUTION.LIB
;
;**********************|
;  erase XGA/8514-a    |
;**********************|
; HEGS (erase graphics screen)
        MOV     AX,13           ; Code number for this service
        LEA     BX,HEGS_DATA    ; Pointer to dummy data block
        CALL    AI_SERVICE
;*******************|
;   exit to DOS     |
;*******************|
DOS_EXIT:
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS
;*****************************************************************
;                           procedures
;*****************************************************************
AI_VECTOR       PROC    NEAR
; Procedure to obtain the address vector to the XGA/8514-A Adapter
; Interface. This procedure must be called before calls are made
; to the Adapter Interface services (by means of the AI_SERVICE
; procedure)
;
; On entry:
;          nothing
; On exit:
;          carry set if no AI installed
;          carry clear if AI present
;             CX => segment of AI link table
;             DX => offset of AI link table
;
;**********************|
;    get vector 7FH    |
;**********************|
; Use MS DOS service number 53, interrupt 21H, to obtain the
; vector for the XGA/8514-A AI interrupt (7FH)
        MOV     AH,53           ; MS DOS service number
        MOV     AL,7FH          ; AI interrupt
        INT     21H             ; MS DOS interrupt
; ES => segment of interrupt handler
; BX => offset of handler
        MOV     AX,ES           ; Segment to AX
        OR      AX,BX           ; OR segment and offset
        JNZ     OK_AI           ; Go if address not 0000:0000
;**********************|
;  ERROR - no AI       |
;**********************|
NO_AI:
        STC                     ; Error return
        RET
;**********************|
;  get AI address      |
;**********************|
; Service number 0105H, interrupt 7FH, returns the address of the
; XGA/8514-A entry point
OK_AI:
        MOV     AX,0105H        ; Service request number
        INT     7FH             ; in XGA AI interrupt
        JC      NO_AI           ; Go if error code returned
; At this point CX:DX holds the address of the XGA/8514-A entry
; point (in segment:offset form)
        CLC                     ; No error code
        RET
AI_VECTOR       ENDP
;*****************************************************************
;
AI_SERVICE      PROC    NEAR
; Procedure to access the services in the XGA/8514-A Adapter
; Interface
;
; On entry:
;         AX = service number
;         DS:BX = address of parameter block
;
        PUSH    BP              ; Save base pointer
        MOV     BP,SP           ; Set BP to stack
; Push address of caller's parameter block
        PUSH    DS
        PUSH    BX              ; the offset
; Multiply by 4 to form offset as required by AI
        SHL     AX,1            ; AX time 2
        SHL     AX,1            ; again
        MOV     SI,AX           ; Offset to SI
        LES     BX,AI_ADD       ; Entry block address (ES:BX)
        CALL    DWORD PTR ES:[BX+SI]      ; Call AI service
        POP     BP              ; Restore caller's BP
        RET
AI_SERVICE      ENDP
;*****************************************************************
;
DO_256          PROC    NEAR
; Display 256 4 by 20 pixels rectangles changing using the palette
; colors
; On entry:
;         DX = y coordinate of start point
;
;
; Store entry parameter
        MOV     RECT_Y,DX       ; Save as HRECT function data
        MOV     RECT_X,0        ; Initialize to first column
        MOV     AH,0            ; AH will holds the color value
        MOV     CX,256          ; Counter for 256 blocks
DO_ONE_RECT:
        PUSH    AX              ; Save color
        PUSH    CX              ; and counter
; Call HSCOL (set color) and HSBCOL (set background color)
        MOV     FORE_COL,AH             ; Color
        MOV     AX,7            ; Code number for this service
        LEA     BX,HSCOL_DATA   ; Pointer to data block
        CALL    AI_SERVICE
; Display a filled rectangle using HRECT function
        MOV     RECT_WIDTH,4    ; width
        MOV     RECT_HIGH,20    ; high
        MOV     AX,32           ; Code number for this service
        LEA     BX,HRECT_DATA   ; Pointer to data block
        CALL    AI_SERVICE
        POP     CX              ; Restore counter
        POP     AX              ; and color
        INC     AH              ; Bump to next color value
        ADD     RECT_X,4        ; move rectangle right
        LOOP    DO_ONE_RECT
 ; All 256 rectangles have been drawn
        RET
DO_256          ENDP
;*****************************************************************
XGA_FONT        PROC    NEAR
; Read an XGA or 8514-a font file into RAM
; On entry:
;         DS:DX --> ASCIIZ filename for font file
;                   (must be in the current path)
;         DS:DI --> RAM buffer for font storage
;
; On exit:
;       Carry clear if font read and stored in buffer
;       Carry set if file not found or disk error
;
; Open font file
        PUSH    DI              ; Save entry pointer
        CALL    OPEN_FILE
        POP     DI
        JNC     OK_XOPEN        ; Go if no error code
;**********************|
;    disk open error   |
;**********************|
; Open operation failed. Set carry flag and return to caller
        STC                     ; Signal error
        RET
;**********************|
;   read font into RAM |
;**********************|
OK_XOPEN:
        MOV     FONT_HANDLE,AX          ; Store file handle
NEW_128:
        MOV     BX,FONT_HANDLE
        LEA     DX,DATA_BUF             ; Buffer for data storage
        PUSH    DI              ; Save buffer pointer
        CALL    READ_128        ; Read sector into buffer
        POP     DI              ; Restore buffer pointer
        CMP     AX,0            ; Test for end of file
        JNE     MOVE_128        ; Go if not at end of file
;**********************|
;    end of file       |
;**********************|
        MOV     BX,FONT_HANDLE  ; Handle for font file
        CALL    CLOSE_FILE      ; Library routine
        JMP     END_OF_READ
;**********************|
;   move sector to     |
;    font buffer       |
;**********************|
; At this point DATA_BUF holds 128 bytes from disk file
; DI --> storage position in the font's buffer
MOVE_128:
        MOV     CX,128          ; Byte counter
        LEA     SI,DATA_BUF     ; Pointer to data just read
PLACE_128:
        MOV     AL,[SI]         ; Byte from DATA_BUF
        MOV     [DI],AL         ; Into font's buffer
        INC     SI              ; Bump pointers
        INC     DI
        LOOP    PLACE_128       ; Continue until all sector read
; At this point the 128 bytes newly read from the disk file are
; stored in the font's buffer
        JMP     NEW_128
END_OF_READ:
        CLC
        RET
XGA_FONT        ENDP
;
;
CODE    ENDS
        END     START           ; Reference to label at which
                                ; execution begins
