;****************************************************************
;****************************************************************
;                           MODE19.ASM
;****************************************************************
;****************************************************************
; Demonstration program for the default color values in VGA mode
; number 19 (see Chapter 3)
;
EXTRN   KBR_WAIT:       FAR
EXTRN   GRAPHIC_TEXT:   FAR
;
INCLUDELIB      SOLUTION
INCLUDELIB      GRAPHSOL
;
;*************************** stack ******************************
;
STACK   SEGMENT stack
;
        DB      0400H DUP ('?')
;
STACK   ENDS
;
;*************************** data *******************************
;
DATA    SEGMENT
;
COUNT_4         DB      4
;
SCREEN_TEXT     DB      0       ; Start at row 0
                DB      0       ; and column 0
                DB      00001111B       ; Bright white
        DB      'Color chart for VGA/XGA 256-color modes',0FFH
        DB      0FFH
        DB      '         <= (00H-0FH) 16 IRGB colors ',0FFH
        DB      0FFH
        DB      '         <= (10H-1FH) 16 gray shades',0FFH,0FFH
        DB      '       3 groups of 72 colors',0FFH
        DB      '1 ....... 24       range    int/sat', 0FFH
        DB      '              <= (20H-37H) high/high',0FFH
        DB      '              <= (38H-4FH) high/mod.',0FFH
        DB      '              <= (50H-67H) high/low ',0FFH
        DB      0FFH
        DB      '              <= (68H-7FH) mod./high',0FFH
        DB      '              <= (80H-97H) mod./mod.',0FFH
        DB      '              <= (98H-AFH) mod./low ',0FFH
        DB      0FFH
        DB      '              <= (B0H-C7H) low/high',0FFH
        DB      '              <= (C8H-DFH) low/mod.',0FFH
        DB      '              <= (E0H-F7H) low/low ',0FFH
        DB      'B   R   G',0FFH,0FFH
        DB      '          F8H-FFH = black'
        DB      0H
;
DATA    ENDS
;
;
;*************************** code *******************************
;
CODE    SEGMENT PUBLIC
        ASSUME  CS:CODE
;
START:
; Initialize DS to establish addressability of data items
        MOV     AX,DATA
        MOV     DS,AX
        ASSUME  DS:DATA
;**********************|
;       init VGA       |
;**********************|
; Set mode number 19 of VGA (color, 320 by 200 pixels)
        MOV     AH,0            ; BIOS service request number
        MOV     AL,19           ; Mode
        INT     10H
; Set ES to VGA video buffer base
        MOV     AX,0A000H
        MOV     ES,AX
; Set write mode for 256 colors
        MOV     AL,0
        CALL    SET_WRITE_256
;**********************|
;    text message      |
;**********************|
        LEA     DI,SCREEN_TEXT  ; Pointer to text message
        CALL    GRAPHIC_TEXT    ; Library procedure
;**********************|
;    color stripes     |
;**********************|
; The color test consists of displaying columns of 8 pixels
; while incrementing the color code
        MOV     AH,0            ; Initial color code
; Calculations for graphics strips:
;  each text row is 8 pixels wide times 320 = 2560 pixels
;**********************|
;      CGA colors      |
;**********************|
        MOV     DI,5120         ; Skip first 2 text rows
STRIPE_1:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,10H          ; Test combinations
        JE      SET_2           ; Finished
        JMP     STRIPE_1
;**********************|
;     gray shades      |
;**********************|
SET_2:
        MOV     DI,10240        ; Pointer to start of display area
STRIPE_2:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,20H          ; End of display range
        JE      SET_3           ; Finished
        JMP     STRIPE_2
;**********************|
;   first 72-color     |
;      block           |
;**********************|
SET_3:
        MOV     DI,20480        ; Pointer to start of display area
        PUSH    DI              ; Save row start
STRIPE_3:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,38H          ; End of display range
        JE      SET_4           ; Finished
        JMP     STRIPE_3
SET_4:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_4:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,50H          ; End of display range
        JE      SET_5           ; Finished
        JMP     STRIPE_4
SET_5:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_5:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,68H          ; End of display range
        JE      SET_6           ; Finished
        JMP     STRIPE_5
;**********************|
;  second 72-color     |
;      block           |
;**********************|
SET_6:
        POP     DI              ; Start of previous row
        ADD     DI,5120         ; Next row
        PUSH    DI
STRIPE_6:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,80H          ; End of display range
        JE      SET_7           ; Finished
        JMP     STRIPE_6
SET_7:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_7:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,98H          ; End of display range
        JE      SET_8           ; Finished
        JMP     STRIPE_7
SET_8:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_8:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,0B0H         ; End of display range
        JE      SET_9           ; Finished
        JMP     STRIPE_8
;**********************|
;   third 72-color     |
;      block           |
;**********************|
SET_9:
        POP     DI              ; Start of previous row
        ADD     DI,5120         ; Next row
        PUSH    DI
STRIPE_9:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,0C8H         ; End of display range
        JE      SET_A           ; Finished
        JMP     STRIPE_9
SET_A:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_A:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,0E0H         ; End of display range
        JE      SET_B           ; Finished
        JMP     STRIPE_A
SET_B:
        POP     DI              ; Start of previous row
        ADD     DI,2560         ; Next row
        PUSH    DI
STRIPE_B:
        CALL    SET_PIXS
        INC     AH              ; Change color code
        CMP     AH,0F8H         ; End of display range
        JE      SET_C           ; Finished
        JMP     STRIPE_B
SET_C:
        CALL    KBR_WAIT
;
EXIT_TO_DOS:
; Reset mode 3
        MOV     AH,0            ; BIOS service request number
        MOV     AL,3            ; 16 color 80 x 25 alphanumeric
        INT     10H
;
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; TO DOS
;****************************************************************
;                           procedures
;****************************************************************
SET_PIXS     PROC    NEAR
; Display a vertical line of 7 pixel rows using the same color
; Each line is 4 pixels wide
        MOV     COUNT_4,4       ; Reset width counter
NEW_COL:
        MOV     CX,7            ; Counter for 7  rows
        PUSH    DI              ; Save buffer pointer
SET_THEM:
        MOV     ES:[DI],AH      ; Color to screen
        ADD     DI,320          ; Bump to next row
        LOOP    SET_THEM
; All columns displayed
        POP     DI              ; Restore pointer
        INC     DI              ; Bump to next column
; All 8 vertical pixels now set
        DEC     COUNT_4         ; Counter for 4 repetitions
        JNZ     NEW_COL
        RET
SET_PIXS     ENDP
;*****************************************************************
;
SET_WRITE_256   PROC     NEAR
; Set the Graphics Controller's Graphic Mode Register to the
; desired write mode in 256 colors
; On entry:
;         AL = write mode requested
; Also set default bit mask
;
        PUSH    AX          ; Save mode
        MOV     DX,3CEH     ; Graphic Controller Address
                            ; Register
        MOV     AL,5        ; Offset of the Mode Register
        OUT     DX,AL       ; Select this register
        JMP     SHORT $+2
        INC     DX          ; Point to data register
        POP     AX          ; Recover mode in AL
; Set bit 6 to enable 256 colors
        OR      AL,01000000B    ; Mask for bit 6
        OUT     DX,AL       ; Selected
        JMP     SHORT $+2
; Set Bit Mask Register to default setting
        MOV     DX,3CEH     ; Graphic controller latch
        MOV     AL,8
        OUT     DX,AL       ; Select data register 8
        JMP     SHORT $+2
        INC     DX          ; To 3CFH
        MOV     AL,0FFH     ; Default mask
        OUT     DX,AL       ; Load bit mask
        JMP     SHORT $+2
        RET
SET_WRITE_256   ENDP
;
CODE    ENDS
        END     START
