$ NOPRINT ERRORPRINT
NAME MATCH0
;*******************************************************************
;*******************************************************************
;                            MATCH0.ASM
;*******************************************************************
;*******************************************************************
;
; Arcade-type game program using timed-pulse and interactive 
; animation
;
; The code has the following system requirements:
; 1. VGA graphics system
; 2. MS DOS 3.0 or later
; 3. IBM PS/2, Microsoft, or compatible mouse, and installed driver
; 4. Font and TIFF files used by the Match program must be in the
;    current path
;
; Note: This version is to be assembled and link using ASM86
;       development tools to generate an 80x87 emulated program
;
;*******************************************************************
;                    public symbols in this module
;*******************************************************************
PUBLIC  START_MAIN
PUBLIC  MOUSE_IMAGE
PUBLIC  DIRECT_EXIT
;*******************************************************************
;                   procedures in SOLUTION.LIB
;*******************************************************************
EXTRN   KBR_FLUSH:      FAR
EXTRN   KBR_STATUS:     FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   DOS_STRING_OUT: FAR
EXTRN   SOUND:          FAR
EXTRN   RANDOM_NUM:     FAR
EXTRN   BIN_TO_ASC:     FAR
EXTRN   BIO_SET_MODE:   FAR
EXTRN   BIO_SET_CUR:    FAR
EXTRN   TIME_VRC:       FAR
EXTRN   COARSE_FILL:    FAR
EXTRN   COARSE_ADD:     FAR
EXTRN   PIXEL_ADD:      FAR
EXTRN   WRITE_PIX:      FAR
EXTRN   SET_WRITE_MODE: FAR
EXTRN   DATA_XOR:       FAR
EXTRN   DATA_NORMAL:    FAR
EXTRN   GRAPHIC_TEXT:   FAR
EXTRN   GRAPHIC_CUR:    FAR
EXTRN   SHOW_CHAR:      FAR
EXTRN   SHOW_BIT_MAP:   FAR
EXTRN   SET_DTA:        FAR
EXTRN   BIO_SHOW_MESS:  FAR
EXTRN   MULTI_TEXT:     FAR
EXTRN   SHOW_TIFF:      FAR
;
; From the GRAFTEXT module
EXTRN   FINE_PATTERN:   FAR
EXTRN   FINE_TEXT:      FAR
EXTRN   FINE_TEXTHP:    FAR
EXTRN   READ_HPFONT:    FAR
EXTRN   COARSE_TEXT:    FAR
EXTRN   COARSE_PATTERN: FAR
EXTRN   INDEX_HP:       FAR
EXTRN   FONT_TO_RAM:    FAR
EXTRN   FONT_X2:        FAR
;
; From Intel emulator software
EXTRN   INIT87:         FAR
;
; External symbols in other modules
EXTRN   BOAR_15X15:     FAR
;
;***************************** stack *******************************
STACK   SEGMENT stack
;
               DB      0800H DUP (00H); Default stack is 2K
STACK_TOP      DW      0
;
STACK   ENDS
;***************************** data ********************************
;
DATA    SEGMENT BYTE    PUBLIC
;**********************|
;   DATA Extenals      |
;**********************|
EXTRN   FONT_1X8:       BYTE
EXTRN   FONT_1X16:      BYTE
EXTRN   FONT_TR9B:      BYTE
EXTRN   FONT_TR6N:      BYTE
EXTRN   TARGET_Y:       BYTE
EXTRN   TARGET_COLOR:   BYTE
EXTRN   TARGE_IMAGE:    WORD
;
;*****************************************************************
;                       main menu screen
;*****************************************************************
; Graphic block
DESC_MS         DW      36      ; Start pixel column (0 to 639)
        DW      130     ; Start pixel row (0 to 479)
        DW      2       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000100B       ; I R G B code (red)
        DB      'A Real-Time Simulation'
        DW      0000H
;
; Graphic block with the copyright notice
COPY_MS         DW      38      ; Start pixel column (0 to 639)
        DW      188     ; Start pixel row (0 to 479)
        DW      2       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000000B       ; I R G B code (red)
        DB      'GRAPHICS SOLUTIONS       '
        DW      000H
;
; Graphic block with address of Skipanon Software
ADDR_MS         DW      38      ; Start pixel column (0 to 639)
        DW      194     ; Start pixel row (0 to 479)
        DW      8       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000000B       ; I R G B code (red)
        DB      'VGA Programming Demonstration        ',00H
;
; Graphic block with the main menu title bar
MENU_MS         DW      15      ; Start pixel column (0 to 639)
        DW      280     ; Start pixel row (0 to 479)
        DW      2       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000001B       ; I R G B code
        DB      'Main MATCH Menu'
        DW      000H
;
; Graphic block with the (r) symbol
REGI_MS         DW      320     ; Start pixel column (0 to 639)
        DW      56      ; Start pixel row (0 to 479)
        DW      0       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000100B       ; I R G B code
        DB      88H
        DW      000H
;
; Instruction message displayed at top right of screen
MOU_MS  DB      45              ; Start column
        DB      4               ; Start row
        DB      00000001B       ; I R G B code
        DB      '   CLICK to               HOLD for',0FFH
        DB      '     select               match',0FFH
        DB      '      match               rules'
        DB      0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
        DB      '   ACTIVE KEYS:',0FFH
        DB      '     <Esc> = End Match Program',00H
;
;**********************|
;   TIFF image blocks  |
;      for main menu   |
;**********************|
; TIFF image graphic block for the word Match
MATCH1_IMAGE    DW      20      ; x coordinate
                DW      32      ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      69      ; Pixel rows in image
                DB      38      ; Bytes per row
                DB      00000100B       ; I R G B CODE
                DB      'MAT2R.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
; Encoding of graphics for mouse drawing
MOUSE_IMAGE     DW      430         ; Present x coordinate         0
                DW      15          ; Present y coordinate         2
                DW      174     ; Offset of bit map in TIFF file
                DW      165     ; Pixel rows in image
                DB      20      ; Bytes per row
                DB      00000001B       ; I R G B CODE
                DB      'MOU1B.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;*************************|
;      menu messages      |
;*************************|
MAIN_MS         DB      2               ; Start column
                DB      19              ; Start row
MAIN_COLOR      DB      00000001B       ; I R G B code
;
MAIN_R1 DB      '1. Running Target Match       ',0FFH
        DB      '2. International Rifle Match  ',0FFH
        DB      '3. International Pistol Match ',0FFH
        DB      '4. Action Pistol Match        ',0FFH
        DB      '5. International Shotgun Match',0FFH
        DB      '6. Rifle Silhouette Match     ',0FFH
        DB      '7. Sighting-in and Set-up     ',0FFH
        DB      00H
;
BRIGHT_MS       DB      2       ; Start column
ROW_NO          DB      19      ; Start row
ROW_COLOR       DB      0       ; Color set by display routine
ROW_X   DB      '                                   ',0FFH
        DB      00H
;
MAIN_ROW        DB      1       ; Start row for main menu
MAIN_LIMIT      DB      7       ; Maximum down movement allowed
MAIN_ON         DB      1       ; Switch for main menu displayed
;
;*****************************************************************
;                 match descriptions and graphics
;*****************************************************************
;**********************|
; TIFF images for menus|
;**********************|
; Running target rifle
RIF2K_IMAGE     DW      310     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      101     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'RIF2K.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF2B_IMAGE     DW      310     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      101     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00001110B       ; I R G B color code
                DB      'RIF2B.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF2W_IMAGE     DW      310     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      101     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'RIF2W.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Slow fire rifle
RIF3K_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'RIF3K.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF3B_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00000110B       ; I R G B color code
                DB      'RIF3B.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF3W_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'RIF3W.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Slow fire pistol
PIS2K_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      129     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'PIS2K.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
PIS2B_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      129     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00000110B       ; I R G B color code
                DB      'PIS2B.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
PIS2W_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      129     ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'PIS2W.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Colt pistol
PIS3K_IMAGE     DW      370     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      179     ; Number of pixel rows
                DB      32      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'PIS3K.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
PIS3B_IMAGE     DW      370     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      179     ; Number of pixel rows
                DB      32      ; Number of bytes per row
                DB      00000110B       ; I R G B color code
                DB      'PIS3B.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
PIS3W_IMAGE     DW      370     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      179     ; Number of pixel rows
                DB      32      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'PIS3W.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Silhouette rifle
RIF4K_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      91      ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'RIF4K.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF4B_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      91      ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00000110B       ; I R G B color code
                DB      'RIF4B.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
RIF4W_IMAGE     DW      302     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      91      ; Number of pixel rows
                DB      40      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'RIF4W.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Shotgun
SGUNK_IMAGE     DW      300     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00000000B       ; I R G B color code
                DB      'SGUNK.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
SGUNB_IMAGE     DW      300     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00000110B       ; I R G B color code
                DB      'SGUNB.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
SGUNW_IMAGE     DW      300     ; x coordinate
                DW      236     ; y coordinate
                DW      174     ; Offset of bit map from start
                                ; of file
                DW      85      ; Number of pixel rows
                DB      42      ; Number of bytes per row
                DB      00001111B       ; I R G B color code
                DB      'SGUNW.TIF',00H
                DB      5 DUP (00H)      ; Padding to 15 bytes
;
; Match description message
; Running target
DESC_M1         DW      315
        DW      336
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'EQUIPMENT AND AMMUNITION:',0FFH
        DB      '.22 Cal. Rimfire for 50 m Courses',0FFH
        DB      '.177 Air Rifle for 10 m Courses',0FFH,0FFH
        DB      'SIGHTS: All types, including scopes',0FFH,0FFH
        DB      'TARGETS:',0FFH
        DB      '10-ring boar for 50 m Courses',0FFH
        DB      '10-ring bullseye for 10 m Courses',0FFH,0FFH
        DB      'FIRING POSITION: Standing, no support',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3606/191',00H
;
; International Rifle
DESC_M2         DW      315
        DW      326
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'EQUIPMENT AND AMMUNITION:',0FFH
        DB      '.22 Cal. smallbore free rifle',0FFH
        DB      '.22 Cal. smallbore standard rifle',0FFH
        DB      '300 meter free rifle (8 mm. max)',0FFH
        DB      'High-power rifle (8 mm max)',0FFH
        DB      '.177 air rifle',0FFH,0FFH
        DB      'SIGHTS: Metal sights, no lenses    ',0FFH,0FFH
        DB      'TARGETS: according to match',0FFH,0FFH
        DB      'FIRING POSITION:',0FFH
        DB      ' Prone, kneeling, and standing',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3624',00H
;
; International Pistol
DESC_M3         DW      315
        DW      330
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      '           EQUIPMENT AND AMMUNITION:',0FFH
        DB      '           .22 Cal. rimfire, .30 to .38',0FFH
        DB      '           Cal. centerfire, and .177 air',0FFH
        DB      '           pistol, according to event',0FFH,0FFH
        DB      'SIGHTS: Metal sights, no lenses    ',0FFH,0FFH
        DB      'TARGETS: according to match',0FFH,0FFH
        DB      'FIRING POSITION: Standing, no support',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3633',00H
;
; Action Pistol
DESC_M4         DW      310
        DW      345
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'EQUIPMENT AND AMMUNITION:',0FFH
        DB      'Any safe, serviceable pistol ',0FFH,0FFH
        DB      'SIGHTS: Optical sights are',0FFH
        DB      '        prohibited',0FFH,0FFH
        DB      'TARGETS: according to match',0FFH,0FFH
        DB      'FIRING POSITION:',0FFH
        DB      'No restrictions on stance or position ',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3559',00H
;
; International Shotgun
DESC_M5         DW      315
        DW      325
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'EQUIPMENT AND AMMUNITION:',0FFH
        DB      'Any shotgun, including semi-automatics,',0FFH
        DB      'that does not exceed 12 gauge. One shell',0FFH
        DB      'is allowed in the magazine. Slings and ',0FFH
        DB      'straps are not allowed',0FFH,0FFH
        DB      'TARGETS: Clay pigeon, 110 mm diameter',0FFH
        DB      'and 25 to 26 mm high',0FFH,0FFH
        DB      'FIRING POSITION: Standing. Competitor',0FFH
        DB      'calls for the target when ready to fire',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3615',00H
;
; Rifle Silhoutte
DESC_M6         DW      315
        DW      325
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'EQUIPMENT AND AMMUNITION:',0FFH
        DB      'High power (6mm or larger), hunting,',0FFH
        DB      'smallbore, air, and black powder rifles,',0FFH
        DB      'according to match',0FFH,0FFH
        DB      'SIGHTS: All types, including scopes',0FFH,0FFH
        DB      'TARGETS: Paper silhouettes of chickens,',0FFH
        DB      'pigs, turkeys, and rams          ',0FFH,0FFH
        DB      'FIRING POSITION: Standing, no support',0FFH
        DB      0FFH
        DB      'NRA PUBLICATION: CI5N3508',00H
;
; Sighting-in and set-up
DESC_M7         DW      315
        DW      280
        DW      8               ; Letter spacing (pixels)
        DW      10              ; Line spacing (pixels)
        DB      00000000B
        DB      'SIGHTING-IN OF GUNS USED IN THE VARIOUS',0FFH
        DB      'MATCHES AND SELECTION OF PROGRAM SPEEDS',0FFH
        DB      'AND OPERATING MODES',00H
;**********************|
;   TIFF image blocks  |
;     for menu No. 1   |
;**********************|
; Running target shooter
SHOT1_IMAGE     DW      300     ; x coordinate
                DW      255     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      225     ; Pixel rows in image
                DB      38      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT1.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;**********************|
;   TIFF image blocks  |
;     for menu No. 2   |
;**********************|
; Slow rifle shooter (lady)
SHOT2_IMAGE     DW      340     ; x coordinate
                DW      244     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      236     ; Pixel rows in image
                DB      28      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT2.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;**********************|
;   TIFF image blocks  |
;     for menu No. 3   |
;**********************|
; Pistol shooter
SHOT3_IMAGE     DW      300     ; x coordinate
                DW      255     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      227     ; Pixel rows in image
                DB      42      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT3.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;**********************|
;   TIFF image blocks  |
;     for menu No. 4   |
;**********************|
; Police pistol shooter
SHOT4_IMAGE     DW      300     ; x coordinate
                DW      248     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      231     ; Pixel rows in image
                DB      38      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT4.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
; Shotgun shooter
SHOT5_IMAGE     DW      320     ; x coordinate
                DW      255     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      227     ; Pixel rows in image
                DB      40      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT5.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
; Siluette shooter
SHOT6_IMAGE     DW      296     ; x coordinate
                DW      234     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      231     ; Pixel rows in image
                DB      42      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT6.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
; Sighting-in operations
SHOT7_IMAGE     DW      296     ; x coordinate
                DW      244     ; y coordinate
                DW      174     ; Offset of bit map in TIFF file
                DW      230     ; Pixel rows in image
                DB      42      ; Bytes per row
                DB      00000110B       ; I R G B CODE
                DB      'SHOT7.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;
;***************************|
;       submenu No. 1       |
;***************************|
; Instruction message displayed at top right of screen
; for sub-menu 1
MOU1_MS DB      45              ; Start column
        DB      4               ; Start row
        DB      00000001B       ; I R G B code
        DB      '   CLICK to               HOLD for',0FFH
        DB      '     select               match',0FFH
        DB      '     course               rules'
        DB      0FFH,0FFH,0FFH,0FFH,0FFH,0FFH
        DB      '               ',0FFH
        DB      '                              ',00H
;
; Graphic block with the main menu title bar
MENU1_MS        DW      10      ; Start pixel column (0 to 639)
        DW      280     ; Start pixel row (0 to 479)
        DW      2       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000101B       ; I R G B code
        DB      'Running Target Match'
        DW      000H
;
SUBMENU_1       DB      2               ; Start column
                DB      19              ; Start row
SUB1_COLOR      DB      00000101B       ; Color is magenta
;
SUB1_R1 DB      '1. 15 + 15 Course (Training) ',0FFH
        DB      '2. 30 + 30 Course (NRA Rules)',0FFH
        DB      '3. 20 + 20 Mixed (NRA Rules) ',0FFH
        DB      '4. Sighting-in and Practice  ',0FFH
        DB      '5. RETURN TO MAIN MATCH MENU ',0FFH
        DB      00H
;
SUB1_ROW        DB      1       ; Start row for submenu 1
SUB1_LIMIT      DB      5       ; Maximum down movement allowed
                                ; for submenu 1
;
;****************************|
; currently active menu data |
;****************************|
MENU_ADD        DW      0       ; Offset of current menu block
ROW1_ADD        DW      0       ; Offset of first text line in
                                ; current menu
MENU_COLOR      DB      0       ; Color of active menu
;
CUR_ROW         DB      0       ; Currently selected menu row
CUR_LIMIT       DB      0       ; Total number of menu rows
XOR_CODE        DB      0       ; Color code to XOR
;****************************|
;      general variables     |
;****************************|
Y_MICKEYS       DW      0       ; Accumulated count of vertical
                                ; mouse movement (in mickeys)
;**********************|
;  Error messages      |
;**********************|
BAD_MOUSE_MS    DB      'Mouse is not operational$'
;
DATA    ENDS
;*******************************************************************
;*******************************************************************
;                             code
;*******************************************************************
;*******************************************************************
CODE_0  SEGMENT BYTE    PUBLIC
        ASSUME  CS:CODE_0, DS:DATA, SS:STACK
;
;*****************************************************************
;                    re-start module
;*****************************************************************
START_MAIN:
;**********************|
;   initialize mouse   |
;**********************|
        MOV     AX,0            ; Reset mouse hardware and software
        INT     33H             ; Mouse service interrupt
        CMP     AX,0            ; Test for error during reset
        JNZ     INIT_VIDEO      ; No problem
;**********************|
; mouse initialization |
;        error         |
;**********************|
; This code executes if there is no mouse installed or no valid
; mouse driver software
        LEA     DX,BAD_MOUSE_MS ; Text message to signal error
        CALL    DOS_STRING_OUT  ; Display error message
        JMP     DIRECT_EXIT
;**********************|
;   initialize video   |
;     buffer address   |
;**********************|
INIT_VIDEO:
        MOV     AX,0A000H       ; AX to base address of video buffer
        MOV     ES,AX           ; To ES
;**********************|
;   set video mode     |
;**********************|
        MOV     AH,0            ; BIOS service request code
        MOV     AL,18           ; VGA mode number 18. 640 by 480
                                ; pixels in 16 colors
        INT     10H             ; BIOS video interrupt
;**********************|
;   set write mode 2   |
;**********************|
; This program uses write mode 2 for graphics display. In this write
; mode the color code is contained in a CPU register
        MOV     AL,2            ; Mode number
        CALL    SET_WRITE_MODE
        CALL    DATA_NORMAL
;**********************|
;  draw color blocks   |
;**********************|
; Fill entire screen
        MOV     CH,0            ; Start column
        MOV     CL,0            ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,60           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
; Display background target
        MOV     TARGET_Y,0      ; Change y coordinate of block
        MOV     TARGET_COLOR,00000010B  ; I R G B code
        LEA     SI,TARGE_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
; Draw top vertical bar
        MOV     CH,46           ; Start column
        MOV     CL,0            ; Start row
        MOV     DH,1            ; Horizontal bytes
        MOV     DL,29           ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
; Draw horizontal bar
        MOV     CH,0            ; Start column
        MOV     CL,29           ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
; Draw vertical bars for menu area
        MOV     CH,36           ; Start column
        MOV     CL,29           ; Start row
        MOV     DH,1            ; Horizontal bytes
        MOV     DL,31           ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
;
; Display TIFF image of the word Match
        LEA     SI,MATCH1_IMAGE          ; Display block
        CALL    SHOW_TIFF
; Display TIFF image of mouse
        LEA     SI,MOUSE_IMAGE          ; Display block
        CALL    SHOW_TIFF
;**********************|
; display text messages|
;**********************|
        LEA     SI,REGI_MS      ; Message for (r) symbol
        LEA     DI,FONT_TR6N    ; Hewlett Packard TR 6 pts
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,DESC_MS      ; Program description text
        LEA     DI,FONT_TR6N    ; Hewlett Packard TR 6 pts
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,COPY_MS      ; Message for copyright notice
        LEA     DI,FONT_TR6N    ; Hewlett Packard TR 6 pts
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,MENU_MS      ; Pointer to message text
        LEA     DI,FONT_TR6N    ; Font table to use
        CALL    FINE_TEXTHP     ; Graphic text procedure
;
        LEA     SI,COPY_MS      ; Message for copyright notice
        LEA     DI,FONT_TR6N    ; Hewlett Packard TR 6 pts
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,ADDR_MS      ; Address message
        LEA     DI,FONT_1x16    ; Font table to use
        CALL    FINE_TEXT       ; Procedure in SOLUTION.LIB
;
        LEA     SI,MOU_MS       ; Instructions text
        LEA     DI,FONT_1X16    ; Font table to use
        CALL    COARSE_TEXT     ; Graphic text procedure
;
;
; Display background shooter image
        LEA     SI,SHOT1_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,MAIN_MS      ; Text for main menu options
        MOV     MENU_ADD,SI     ; Set as current menu
        MOV     AL,MAIN_COLOR   ; Color of main menu
        MOV     MENU_COLOR,AL   ; Store in display variable
        LEA     SI,MAIN_R1      ; First row in message block
        MOV     ROW1_ADD,SI     ; Set as current first row
;
        MOV     AL,1            ; Start menu row
        MOV     MAIN_ROW,AL     ; Set in main menu active row
        MOV     CUR_ROW,AL      ; and as currently displayed row
        CALL    MENU_ROW        ; Routine to set active row to
                                ; a new color code
        CALL    KBR_FLUSH       ; Flush keyboard buffer
; Reset active menu row to first row and mickey counter
        MOV     MAIN_ROW,1
        MOV     Y_MICKEYS,0
;
;*******************************************************************
;                       MAIN MENU PROCESSING
;*******************************************************************
MAIN_MENU:
        MOV     MAIN_ON,1       ; Main menu displayed
        LEA     DI,MAIN_MS       ; Offset of menu block
        MOV     MENU_ADD,DI     ; To variable
        MOV     AL,MAIN_COLOR   ; Color of main menu
        MOV     MENU_COLOR,AL   ; Store in display variable
        LEA     SI,MAIN_R1      ; First row in message block
        MOV     ROW1_ADD,SI     ; Set as current first row
        MOV     AL,MAIN_ROW     ; Currently selected menu row
        MOV     CUR_ROW,AL      ; To variable
        MOV     AL,MAIN_LIMIT   ; Total rows in menu
        MOV     CUR_LIMIT,AL    ; To variable
REP_MAIN:
        CALL    MENU_ACTION     ; Local mouse action procedure
        JC      SELECT_SUB      ; Go if left button pressed
; Update active menu row variable
        MOV     AL,CUR_ROW      ; Modified by MENU_ACTION procedure
        MOV     MAIN_ROW,AL     ; To main menu control
        CALL    TEST_RIGHT_B    ; Test for right button pressed
;**********************|
;  Test for <Esc> key  |
;**********************|
        CALL    KBR_STATUS      ; Procdure in SOLUTION.LIB
        JNC     NO_KEYSTROKE    ; Go if no carry
; At this point there is a keystroke in the keyboard buffer
        CALL    KBR_WAIT        ; Get the keystroke
        CMP     AX,011BH        ; Is it the <Esc> key
        JNE     NO_KEYSTROKE    ; Ignore it if not <Esc>
        JMP     DOS_EXIT        ; End execution
NO_KEYSTROKE:
        JMP     REP_MAIN
;****************************|
;  left button was pressed   |
;       select submenu       |
;****************************|
SELECT_SUB:
; The MAIN_ROW variable holds the currently selected menu item
        CMP     MAIN_ROW,1      ; Test for first match
        JNE     TEST_M2         ; Cascade to next
        JMP     MATCH_1         ; Go to first menu item
; Test for second menu item
TEST_M2:
        NOP
TEST_M10:
        CMP     MAIN_ROW,10     ; Test for first match
        JNE     MAIN_TEST_EXIT  ; End of cascaded tests
        JMP     DOS_EXIT        ; End program execution
MAIN_TEST_EXIT:
        JMP     MAIN_MENU
;
;*****************************************************************
;                     running target match
;*****************************************************************
MATCH_1:
        MOV     MAIN_ON,0       ; Main menu not displayed
; Display mouse text message
; Erase menu area
        MOV     CH,47           ; Start column
        MOV     CL,0            ; Start row
        MOV     DH,33           ; Horizontal bytes
        MOV     DL,29           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
;
; Display TIFF image of mouse
        LEA     SI,MOUSE_IMAGE          ; Display block
        CALL    SHOW_TIFF
;
        LEA     SI,MOU1_MS      ; Instructions text
        LEA     DI,FONT_1X16    ; Font table to use
        CALL    COARSE_TEXT     ; Graphic text procedure
;
; Erase main menu
        CALL    CLEAR_MENU
; Reset first menu line as active
        MOV     SUB1_ROW,1
; Set display variables for sub-menu 1
        LEA     SI,MENU1_MS     ; Pointer to message text
        LEA     DI,FONT_TR6N    ; Font table to use
        CALL    FINE_TEXTHP     ; Graphic text procedure
;
        LEA     SI,SUBMENU_1    ; Text for main menu options
        MOV     MENU_ADD,SI     ; Set as current menu
        MOV     AL,SUB1_COLOR   ; Color of this submenu
        MOV     MENU_COLOR,AL   ; Stored in display variable
        LEA     SI,SUB1_R1      ; First row in message block
        MOV     ROW1_ADD,SI     ; Set as current first row
        MOV     CUR_ROW,1       ; Set first row as active
        MOV     AL,SUB1_LIMIT   ; Total rows in menu
        MOV     CUR_LIMIT,AL    ; To variable
        CALL    MENU_ROW
MONITOR_1:
        CALL    MENU_ACTION     ; Local mouse action procedure
        JC      SELECT_SUB1     ; Go if left button pressed
        CALL    TEST_RIGHT_B    ; Test for right button pressed
; Update active menu row variable
        MOV     AL,CUR_ROW      ; Modified by MENU_ACTION procedure
        MOV     SUB1_ROW,AL     ; To main menu control
        JMP     MONITOR_1
;****************************|
;  left button was pressed   |
;       select submenu       |
;****************************|
SELECT_SUB1:
; The SUB1_ROW variable holds the currently selected menu item
        CMP     SUB1_ROW,1      ; Test for first course
        JNE     TEST_S12        ; Cascade to next
        JMP     BOAR_15X15      ; Go to first menu item
; Test for second menu item
TEST_S12:
TEST_S13:
        NOP
;
        CMP     SUB1_ROW,5      ; Test for exit line
        JNE     SUB1_TEST_EXIT  ; End of cascaded tests
        JMP     START_MAIN      ; End submenu and restart main
                                ; program
SUB1_TEST_EXIT:
        JMP     MONITOR_1
;
;****************************************************************
;                         program exit
;****************************************************************
DOS_EXIT:
        MOV     AL,3            ; Set alphanumeric mode 3
        CALL    BIO_SET_MODE    ; Procedure in SOLUTION.LIB
;
DIRECT_EXIT:
        MOV     AH,4CH          ; DOS service request code
        MOV     AL,0            ; No error code returned
        INT     21H             ; exit to MS DOS
;
;*******************************************************************
;                       local procedures
;*******************************************************************
CLEAR_MENU      PROC    NEAR
; Erase menu area
        MOV     CH,0            ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,33           ; Horizontal bytes
        MOV     DL,30           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
        RET
CLEAR_MENU      ENDP
;******************************************************************
;
MENU_ACTION     PROC    NEAR
; Report button press
; If vertical mouse action is detected select new menu line on
; currently displayed menu
; The following variables hold menu data
;    MENU_ADD   WORD = Offset of current menu display block
;    CUR_ROW    BYTE = Currently active menu row
;    CUR_LIMIT  BYTE = Total number of menu rows
;
; On exit:
;       CARRY SET = left mouse button pressed
;
;****************************|
; test for left button press |
;****************************|
        MOV     AX,5            ; Service request number
        MOV     BX,0            ; Left button request code
        INT     33H             ; Mouse interrupt
; BX not zero if left button pressed
        CMP     BX,0            ; Test for no press
        JZ      MOUSE_MOTION
; Left button pressed. Return with carry set
        STC
        RET
;*************************|
;  test for mouse motion  |
;*************************|
MOUSE_MOTION:
; Test for vertical motion of mouse using service number 11 of
; INT 33H. This service returns the signed vertical movement
; (in mickeys) in DX
        MOV     AX,11           ; Service request number
        INT     33H             ; Mouse interrupt
; Count is accumulated in the Y_MICKEYS variable
        MOV     AX,Y_MICKEYS    ; Variable to AX
        ADD     AX,DX           ; Accumulate count in AX
        MOV     Y_MICKEYS,AX    ; Store accumulated count
; AX holds accumulated vertical mouse motion
; A motion of +/- 15 mickeys updates the selected menu item
        CMP     AX,15           ; Down movement limit
        JGE     MOVE_DOWN       ; Down movement routine
        CMP     AX,-15           ; Up movement limit
        JLE     MOVE_UP         ; Up movement routine
; Not sufficient mouse movement
        JMP     ACTION_EXIT
;***************************|
;   select next menu item   |
;***************************|
; Mouse movement exceeds threshhold of +10 mickeys
MOVE_DOWN:
        MOV     AL,CUR_ROW      ; Current active menu row
        CMP     AL,CUR_LIMIT    ; Test for bottom row
        JNE     NOT_BOTTOM      ; Go if not at menu bottom
        JMP     ACTION_EXIT     ; Continue if at bottom
NOT_BOTTOM:
        MOV     Y_MICKEYS,0     ; Reset accumulation counter
; Set selected row to new color code
        INC     CUR_ROW         ; Bump to next row
; Bump active menu row if main menu displayed
        CMP     MAIN_ON,1       ; Test main menu switch
        JNE     MAIN_IS_OFF     ; Go if not on
        INC     MAIN_ROW
MAIN_IS_OFF:
        CALL    MENU_ROW
        CALL    MENU_IMAGE
        JMP     ACTION_EXIT
;***************************|
; select previous menu item |
;***************************|
; Mouse movement exceeds threshhold of -10 mickeys
MOVE_UP:
        MOV     AL,CUR_ROW      ; Current active menu row
        CMP     AL,1            ; Test for top row
        JNE     NOT_TOP         ; Go if not at top
        JMP     ACTION_EXIT     ; Continue if at bottom
NOT_TOP:
        MOV     Y_MICKEYS,0     ; Reset accumulation counter
; Set selected row to new color code
        DEC     CUR_ROW         ; Bump to next row
; Bump active menu row if main menu displayed
        CMP     MAIN_ON,1       ; Test main menu switch
        JNE     MAIN_IS_OFF1    ; Go if not on
        DEC     MAIN_ROW
MAIN_IS_OFF1:
        CALL    MENU_ROW        ; Update display
        JNE     ACTION_EXIT     ; Go if not
        CALL    MENU_IMAGE
ACTION_EXIT:
        CLC
        RET
MENU_ACTION     ENDP
;******************************************************************
;
MENU_ROW        PROC    NEAR
; Set menu row to enhanced color
; On entry:
;   DS:CUR_ROW holds menu row number to enhance (range 1 to 10)
;
        MOV     AL,CUR_ROW      ; Current row to AL
        MOV     CL,AL           ; Set up counter
        MOV     CH,0            ; Clear high byte of counter
        MOV     SI,ROW1_ADD     ; Text for first menu row
        LEA     DI,ROW_X        ; Destination text block area
; Get display color and set bright bit for active row
        MOV     AH,MENU_COLOR   ; Color code for current menu
        OR      AH,00001000B    ; Set bit number 3
        MOV     ROW_COLOR,AH    ; Store in bright line block
        DEC     AL              ; Adjust range
        ADD     AL,19           ; Add start row number
        MOV     ROW_NO,AL       ; Set row number in text block
        DEC     CX              ; Adjust range of counter
        JZ      MOVE_MENU_ROW   ; Go if first row
INDEX_TO_ROW:
        CMP     BYTE PTR [SI],0FFH      ; Test for end of row
        JE      MENU_ROW_END    ; Go if end of menu row
        INC     SI              ; Bump pointer
        JMP     INDEX_TO_ROW    ; Continue search for 0FFH
MENU_ROW_END:
        INC     SI              ; Skip row terminator
        LOOP    INDEX_TO_ROW    ; Continue if not at end
; At this point SI ==> the text of the active menu row
MOVE_MENU_ROW:
        MOV     AL,[SI]         ; Get character
        CMP     AL,0FFH         ; Test for end of row
        JE      MENU_READY      ; Go if all row moved
        MOV     [DI],AL         ; Place in row block
        INC     DI              ; Bump pointers
        INC     SI
        JMP     MOVE_MENU_ROW   ; Continue moving row
;**********************|
;       display        |
;**********************|
MENU_READY:
        MOV     SI,MENU_ADD     ; Pointer to message text
        LEA     DI,FONT_1X16    ; Font table to use
        CALL    COARSE_TEXT     ; Graphic text procedure
;
        LEA     SI,BRIGHT_MS    ; Pointer to bright row block
        LEA     DI,FONT_1X16    ; Font table to use
        CALL    COARSE_TEXT     ; Graphic text procedure
        RET
MENU_ROW        ENDP
;*****************************************************************
;
MENU_IMAGE      PROC    NEAR
; Display corresponding line drawing according to active menu row
; of main menu
;    MAIN_ROW   BYTE = Currently active main menu row
;
        CMP     MAIN_ON,1       ; Test for main menu displayed
        JE      MAIN_IS_ON      ; Go if main displayed
        RET
MENU_IMAGE1     PROC
; First clear match description area
MAIN_IS_ON:
        MOV     CH,37           ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,43           ; Horizontal bytes
        MOV     DL,30           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
; Select main menu image
        CMP     MAIN_ROW,1      ; Test for active menu
        JE      IMAGE_MENU1
        CMP     MAIN_ROW,2
        JE      IMAGE_MENU2
        CMP     MAIN_ROW,3
        JE      IMAGE_MENU3
        CMP     MAIN_ROW,4
        JE      IMAGE_MENU4
        CMP     MAIN_ROW,5
        JE      IMAGE_MENU5
        CMP     MAIN_ROW,6
        JE      IMAGE_MENU6
        JMP     IMAGE_MENU7
IMAGE_MENU1:
        LEA     SI,SHOT1_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU2:
        LEA     SI,SHOT2_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU3:
        LEA     SI,SHOT3_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU4:
        LEA     SI,SHOT4_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU5:
        LEA     SI,SHOT5_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU6:
        LEA     SI,SHOT6_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
IMAGE_MENU7:
        LEA     SI,SHOT7_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        RET
;
MENU_IMAGE1     ENDP
MENU_IMAGE      ENDP
;*****************************************************************
;
TEST_RIGHT_B    PROC    NEAR
; Get press status of right mouse button
        MOV     AX,5            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button presses
        CMP     BX,0            ; Test for no press
        JNE     BUTTON_DOWN     ; Go if pressed
        CLC                     ; Return flag
        RET
; If right button is down erase menu info area and display rules
; for selected main menu option
BUTTON_DOWN:
;**********************|
;    flush mouse       |
;**********************|
; Use mouse service number 6 to test for right button released
; and flush action
; Carry set if button was pressed
FLUSH_RELEASE:
        MOV     AX,6            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button releases
        CMP     BX,0            ; Test for no pending action
        JNE     FLUSH_RELEASE   ; Go if released
; Clear match description area
        MOV     CH,37           ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,43           ; Horizontal bytes
        MOV     DL,30           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
;
        CMP     MAIN_ROW,1      ; Test for active menu
        JNE     TEST_ROW2
        JMP     RULES_MENU1
TEST_ROW2:
        CMP     MAIN_ROW,2
        JNE     TEST_ROW3
        JMP     RULES_MENU2
TEST_ROW3:
        CMP     MAIN_ROW,3
        JNE     TEST_ROW4
        JMP     RULES_MENU3
TEST_ROW4:
        CMP     MAIN_ROW,4
        JNE     TEST_ROW5
        JMP     RULES_MENU4
TEST_ROW5:
        CMP     MAIN_ROW,5
        JNE     TEST_ROW6
        JMP     RULES_MENU5
TEST_ROW6:
        CMP     MAIN_ROW,6
        JNE     TEST_ROW7
        JMP     RULES_MENU6
TEST_ROW7:
        JMP     RULES_MENU7
;
RULES_MENU1:
; TIFF image of running target rifle
        LEA     SI,RIF2B_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF2K_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF2W_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
; Text
        LEA     SI,DESC_M1      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
RULES_MENU2:
; TIFF image of slow fire rifle
        LEA     SI,RIF3B_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF3K_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF3W_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,DESC_M2      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
RULES_MENU3:
; TIFF image of slow fire rifle
        LEA     SI,PIS2B_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,PIS2K_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,PIS2W_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,DESC_M3      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
RULES_MENU4:
; TIFF image of Colt pistol
        LEA     SI,PIS3B_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,PIS3K_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,PIS3W_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,DESC_M4      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
RULES_MENU5:
; TIFF image of Shotgun
        LEA     SI,SGUNB_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,SGUNK_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,SGUNW_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,DESC_M5      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
RULES_MENU6:
; TIFF image of Silhouette rifle
        LEA     SI,RIF4B_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF4K_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,RIF4W_IMAGE
        CALL    SHOW_TIFF       ; Display rountine for TIFF
        LEA     SI,DESC_M6      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
RULES_MENU7:
        LEA     SI,DESC_M7      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
        JMP     RELEASE_WAIT
;
;**********************|
; wait for right button|
;       release        |
;**********************|
RELEASE_WAIT:
; Get release status of right mouse button
        MOV     AX,6            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button right button releases
        CMP     BX,0            ; Test for no press
        JNE     BUTTON_UP       ; Go if pressed
        JMP     RELEASE_WAIT
BUTTON_UP:
; Redisplay line drawing according to menu
        CALL    MENU_IMAGE1
;**********************|
;    flush mouse       |
;**********************|
; Use mouse service number 5 to test for right button pressed
; Carry set if button was pressed
FLUSH_IT:
        MOV     AX,5            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button presses
        CMP     BX,0            ; Test for no press
        JNE     FLUSH_IT        ; Go if pressed
        RET
TEST_RIGHT_B    ENDP
;
CODE_0  ENDS
        END

 no press
        JNE     FLUSH_IT        ; Go if pressed
        RET
TEST_RIGHT_B    EN