$ NOPRINT ERRORPRINT
NAME MATCH1
;*******************************************************************
;*******************************************************************
;                            MATCHC.ASM
;                      running boar rifle match
;                          15 + 15 Course
;*******************************************************************
;*******************************************************************
;
;*******************************************************************
;                          p u b l i c s
;*******************************************************************
PUBLIC  BOAR_15X15

PUBLIC  HEX0A_INT
PUBLIC  CROSS_X
PUBLIC  CROSS_Y
PUBLIC  CR_COL
PUBLIC  RUN_CNT
PUBLIC  MATCH_CNT
PUBLIC  NUM_BUFFER
PUBLIC  SCORE_CNT
PUBLIC  COUNT_8
PUBLIC  BYTES
PUBLIC  X_COORD
PUBLIC  BOAR_OFF
PUBLIC  MATCH_NUM
PUBLIC  RUN_NUM
PUBLIC  LAST_SCORE
PUBLIC  TOTAL_POINTS
PUBLIC  THIS_CNT
PUBLIC  X_VALUE
PUBLIC  Y_VALUE
PUBLIC  HIT_SW
PUBLIC  RUN_SW
PUBLIC  OLD_VECTOR_0A
PUBLIC  CRT_PORT
PUBLIC  AR_BYTE
PUBLIC  OLD_VRE
PUBLIC  NEW_RUN
PUBLIC  ACTIVE_BOAR
PUBLIC  RPIG_X
PUBLIC  RPIG_Y
PUBLIC  LPIG_X
PUBLIC  LPIG_Y
PUBLIC  GUN_LOADED
PUBLIC  BOAR_SPEED
PUBLIC  GUN_FIRED
PUBLIC  GRASS_X
PUBLIC  GRASS_Y
PUBLIC  GRASS_COLOR
PUBLIC  FIRST_DUCK
PUBLIC  TIMER_COUNT
PUBLIC  SPEED_SW
PUBLIC  COM_SW
PUBLIC  BOAR_MATCH_EXIT
;
; Public equates
PUBLIC  TOTAL_RUNS
PUBLIC  ON_X
PUBLIC  ON_Y
;
;*******************************************************************
;                         e x t e r n a l s
;*******************************************************************
; Procedures in SOLUTION.LIB
EXTRN   KBR_FLUSH:      FAR
EXTRN   KBR_STATUS:     FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   SOUND:          FAR
EXTRN   RANDOM_NUM:     FAR
EXTRN   BIN_TO_ASC:     FAR
EXTRN   BIO_SET_MODE:   FAR
EXTRN   COARSE_FILL:    FAR
EXTRN   COARSE_ADD:     FAR
EXTRN   SET_WRITE_MODE: FAR
EXTRN   DATA_XOR:       FAR
EXTRN   DATA_NORMAL:    FAR
EXTRN   MILLI_TIME:     FAR
EXTRN   SHOW_BIT_MAP:   FAR
EXTRN   FINE_TEXTHP:    FAR
EXTRN   COARSE_TEXT:    FAR
EXTRN   MULTI_TEXT:     FAR
EXTRN   FINE_TEXT:      FAR
EXTRN   SHOW_TIFF:      FAR
;
; External label in MATCH0
EXTRN   START_MAIN:     FAR
;
;
;**************************** equates ******************************
; Limits of cursor movement
; The following values limit the movement of the crosshair symbol
; to the gray rectangular area
CUR_LIM_RIGHT   EQU     620
CUR_LIM_LEFT    EQU     5
CUR_LIM_UP      EQU     362
CUR_LIM_DOWN    EQU     454
;
; The following values determine the on-target error allowance
; Increasing these values makes scoring easier, and vice versa
; Units are screen pixels
ON_X            EQU      10
ON_Y            EQU      10
;
; The following value determines the speed at which the boar travels
; across the screen. Increasing this value will make the boar
; travel faster
PRIME_SPEED     EQU     2
;
; The following equates relate to match size and scoring
TOTAL_RUNS      EQU     38      ; Boar runs per match
;
;************************** dummy stack **************************
STACK   SEGMENT stack
EXTRN   STACK_TOP:      WORD
;
;
STACK   ENDS
;***************************** data ********************************
;
DATA    SEGMENT BYTE    PUBLIC
; Externals from other Match modules
EXTRN   FONT_TR9B:      BYTE    ; MATCH0
EXTRN   FONT_TR6N:      BYTE
EXTRN   FONT_1X16:      BYTE
EXTRN   FONT_1X8:       BYTE
EXTRN   MOUSE_IMAGE:    WORD
EXTRN   SCOPE_SW:       BYTE    ; MATCH1A
;
;**********************|
;  parameter storage   |
;**********************|
NUM_BUFFER      DB      5 DUP(00H)      ; 5-digit buffer used by
                DW      0       ; conversion routines
;
;**********************|
;     text blocks      |
;**********************|
; Graphic block message for the match
RUNTAR_MS       DW      8       ; Start pixel column (0 to 639)
        DW      37      ; Start pixel row (0 to 479)
        DW      0       ; Horizontal pixel spacing
        DW      0       ; Vertical pixel spacing
        DB      00000100B       ; I R G B code (red)
        DB      'Running Target Match',00H
        DW      0000H
;
; Graphic block message for the match
X3030_MS        DW      205
        DW      67
        DW      0
        DW      0
        DB      00000100B
        DB      '15',00H
        DW      0000H
;
X3030A_MS       DW      234
        DW      67
        DW      1
        DW      0
        DB      00000100B
        DB      '+15 Course',00H
        DW      0000H
;
; Match description message
DESC_MS         DW      192
        DW      76
        DW      8
        DW      12
        DB      00000000B
        DB      '  COURSE DESCRIPTION',0FFH
        DB      '1. Running boars start',0FFH
        DB      'alternatively at right',0FFH
        DB      'and left.            ',0FFH
        DB      '2. Total shots = 38. ',0FFH
        DB      'First 19 shots are   ',0FFH
        DB      'slow, next 19 are fast',0FFH
        DB      '3. First 4 shots in  ',0FFH
        DB      'the slow and the fast',0FFH
        DB      'series are practice  ',0FFH
        DB      'shots                ',0FFH
        DB      '4. Only one shot can ',0FFH
        DB      'be fired at each run ',00H
        DB      00H
;
MOU1_MS DB      45              ; Start column
        DB      4               ; Start row
        DB      00000001B       ; I R G B code
        DB      '   CLICK to               CLICK to',0FFH
        DB      '       FIRE               LOAD ',0FFH
        DB      0FFH,0FFH,0FFH,0FFH,0FFH
        DB      '   ACTIVE KEYS:',0FFH
        DB      '     <F1> = Spotting scope ON/OFF',0FFH
        DB      '     <Esc> = Terminate Match',00H
;
;**********************|
;    scoreboard text   |
;**********************|
; Text messages and graphics displayed at the scoreboard area
SCORE_MS        DW      70
        DW      264
        DW      4
        DW      0
        DB      00001111B
        DB      'Match Status          Scoreboard'
        DB      00H
;
BOT_MS  DB      42              ; Column
        DB      17              ; row
        DB      00001111B       ; Color
        DB      '  MATCH   LAST             MATCH',0FFH
        DB      '  NUMBER  RUN NO.  SCORE   POINTS',0FFH
        DB      20H,0C9H
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CBH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CBH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CBH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0BBH,0FFH,0FFH
        DB      20H,0C8H
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CAH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CAH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0CAH
        DB      0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH,0CDH
        DB      0BCH,0FFH
        DW      00H
;
; Line with variable data is not contained in this block
; but in the DATA_LN block
;
DATA_L1 DB      42
        DB      20
        DB      00001111B
        DB      20H,0BAH,20H,20H
MATCH_NUM       DB      ' 1',20H,20H,20H,0BAH,20H
RUN_NUM         DB      ' 0/38 ',0BAH,20H
LAST_SCORE      DB      ' 0/10',020H,0BAH,20H
TOTAL_POINTS    DB      '  0/300',20H,0BAH,00H
;
; Text message displayed at the end of the match
MATCHEND_MS     DW      210     ; Start pixel column (0 to 639)
        DW      370     ; Start pixel row (0 to 479)
        DW      8       ; Horizontal pixel spacing
        DW      18      ; Pixel spacing between text lines
        DB      00000111B       ; I R G B color code
        DB      '  E N D   O F   M A T C H ',0FFH
        DB      ' press any key to continue           ',0H
;
;
; Message selection switches
COM_SW          DB      0       ; Selector for command message
RUN_SW          DB      0       ; Selector for run type message
SPEED_SW        DB      0       ; Selector for run speed message
;
;**********************|
;   program controls   |
;**********************|
MATCH_CNT       DB      1       ; Counter for game number
RUN_CNT         DB      0       ; Counter for boar runs
THIS_CNT        DB      0       ; Score for last run
SCORE_CNT       DW      0       ; Game score counter
;
TIMER_COUNT     DW      0       ; Counter for delay routine
;
DATA    ENDS
;
;****************************** code *******************************
;
CODE_1  SEGMENT BYTE    PUBLIC
;
; Externals from MATCH1A.ASM
EXTRN   MOVE_CURSOR:    NEAR
EXTRN   UPDATE_X:       NEAR
EXTRN   UPDATE_Y:       NEAR
EXTRN   XOR_XHAIR:      NEAR
EXTRN   SCOREBOARD:     NEAR
EXTRN   GET_SCORE:      NEAR
EXTRN   MOVE_CX_DIGS:   NEAR
EXTRN   VARI_MAP:       NEAR
EXTRN   SCOPE_ON:       NEAR
EXTRN   SCOPE_OFF:      NEAR
EXTRN   MOUSE_MOVE:     NEAR
EXTRN   TEST_4_KEY:     NEAR
EXTRN   FLUSH_MOUSE:    NEAR
EXTRN   TEST_4_LOAD:    NEAR
EXTRN   RUN_DELAY:      NEAR
EXTRN   SHOW_STATUS:    NEAR
EXTRN   SCORE_LINE:     NEAR
;
;
; Externals from MATCH1B.ASM
EXTRN   VRI_ON:         NEAR
EXTRN   VRI_OFF:        NEAR
EXTRN   MOUSE_BUT:      FAR
;
;
        ASSUME  CS:CODE_1, SS:STACK, DS:DATA
;
BOAR_15X15:
;****************************|
;  install vertical retrace  |
;          interrupt         |
;****************************|
        MOV     DI,OFFSET HEX0A_INT    ; Address of handler
        CALL    VRI_ON          ; Procedure in MATCH1B.ASM
;**********************|
;   initialize video   |
;     buffer address   |
;**********************|
        MOV     AX,0A000H       ; AX to base address of video buffer
        MOV     ES,AX           ; To ES
;**********************|
;   set write mode 2   |
;**********************|
; This program uses write mode 2 for graphics display
; In this write mode the pixel color code is contained in a CPU
; register
        MOV     AL,2            ; Mode number
        CALL    SET_WRITE_MODE
;**********************|
;  draw color blocks   |
;**********************|
; Fill entire screen
        MOV     CH,0            ; Start column
        MOV     CL,0            ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,60           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
; Draw thick gray stripe for duck movements
        MOV     CH,0            ; Start column
        MOV     CL,44           ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,16           ; Vertical bytes
        MOV     AL,00001000B    ; Color = gray
        CALL    COARSE_FILL
; Draw top vertical line
        MOV     CH,46           ; Start column
        MOV     CL,0            ; Start row
        MOV     DH,1            ; Horizontal bytes
        MOV     DL,29           ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
; Draw black horizontal line
        MOV     CH,0            ; Start column
        MOV     CL,29           ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
;
; Black horizontal and vertical line for target area
        MOV     CH,0            ; Start column
        MOV     CL,7            ; Start row
        MOV     DH,22           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
;
        MOV     CH,22           ; Start column
        MOV     CL,7            ; Start row
        MOV     DH,1            ; Horizontal bytes
        MOV     DL,23           ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
;
        MOV     CH,0            ; Start column
        MOV     CL,44           ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000100B    ; Color = red
;
        CALL    COARSE_FILL
        MOV     CH,0            ; Start column
        MOV     CL,59           ; Start row
        MOV     DH,80           ; Horizontal bytes
        MOV     DL,1            ; Vertical bytes
        MOV     AL,00000100B    ; Color = red
        CALL    COARSE_FILL
;
; Draw scoreboard framing lines
        MOV     CH,39           ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,1            ; Horizontal bytes
        MOV     DL,14           ; Vertical bytes
        MOV     AL,00000000B    ; Color = black
        CALL    COARSE_FILL
;
; Draw blue scoreboard area
        MOV     CH,40           ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,40           ; Horizontal bytes
        MOV     DL,14           ; Vertical bytes
        MOV     AL,00000001B    ; Blue
        CALL    COARSE_FILL
;
; Draw green status area
        MOV     CH,00           ; Start column
        MOV     CL,30           ; Start row
        MOV     DH,39           ; Horizontal bytes
        MOV     DL,14           ; Vertical bytes
        MOV     AL,00000010B    ; Green
        CALL    COARSE_FILL
; Display mouse
        LEA     SI,MOUSE_IMAGE
        CALL    SHOW_TIFF
;
; Display grass area
        MOV     CX,20           ; Counter for 20 interations
        MOV     CS:GRASS_X,0    ; Reset start of grass area
GRASS_LOT:
        LEA     SI,CS:GRASS_X   ; Offset of display block
        LEA     BX,CS:GRASS_COLOR
        PUSH    CX              ; Save counter
        CALL    VARI_MAP        ; Display routine
        POP     CX
        ADD     CS:GRASS_X,32   ; Index 32 pixels
        LOOP    GRASS_LOT
;**********************|
; display text messages|
;**********************|
        LEA     SI,RUNTAR_MS    ; Pointer to message text
        LEA     DI,FONT_TR9B
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,X3030_MS     ; Pointer to message text
        LEA     DI,FONT_TR6N
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,X3030A_MS    ; Pointer to message text
        LEA     DI,FONT_TR6N
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,MOU1_MS      ; Pointer to instructions text
        LEA     DI,FONT_1X16
        CALL    COARSE_TEXT     ; Procedure in SOLUTION.LIB
;
        LEA     SI,DESC_MS      ; Pointer to instructions text
        LEA     DI,FONT_1X8
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
;
        LEA     SI,SCORE_MS     ; Pointer to message text
        LEA     DI,FONT_TR6N
        CALL    FINE_TEXTHP     ; Procedure in SOLUTION.LIB
;
        LEA     SI,BOT_MS       ; Scoreboard text
        LEA     DI,FONT_1X16
        CALL    COARSE_TEXT
;
;**********************|
;   clear scoreboard   |
;**********************|
        MOV     RUN_CNT,0       ; Reset variables
        MOV     CS:X_VALUE,0
        MOV     CS:Y_VALUE,0
        MOV     SCORE_CNT,0
        MOV     THIS_CNT,0
        MOV     RUN_SW,1
        MOV     CS:HIT_SW,0
; Move text into scoreboard text line
        LEA     SI,DATA_L1      ; Text for this course
        CALL    SCORE_LINE
; Display score and scoreboard
        CALL    GET_SCORE
        CALL    SCOREBOARD      ; Display variable text line
; Display target
        MOV     SCOPE_SW,0      ; Set scope off switch
        CALL    SCOPE_OFF       ; Display graphics
        MOV     COM_SW,0        ; LOAD status message
;**********************|
;  set mouse interrupt |
;**********************|
; Set address of interrupt service routine for left mouse button
; pressed (fire gun operation) and for right button pressed
; (start new game operation)
        CLI                     ; Interrupts off
        PUSH    ES              ; Save video buffer segment
        PUSH    CS              ; Program's segment
        POP     ES              ; to ES
        MOV     AX,12           ; Mouse service number 12
; Interrupt mask bit map:
;  15 ----------------------5 4 3 2 1 0
;  |-- these bits unused ---| | | | | |___ Cursor position changed
;                             | | | |_____ Left button pressed
;                             | | |_______ Left button released
;                             | |_________ Right button pressed
;                             |___________ Right button released
        MOV     CH,0            ; Unused bits
        MOV     CL,00000010B    ; Interrupt on left button pressed
        MOV     DX,OFFSET MOUSE_BUT
        INT     33H             ; Mouse interrupt
        POP     ES              ; Restore segment
        STI                     ; Interrupts on
;
;**********************|
;  set XOR data mode   |
;**********************|
        CALL    DATA_XOR
;**********************|
;   reset variables    |
;**********************|
        MOV     CS:BOAR_SPEED,PRIME_SPEED       ; Set speed to
                                        ; equated value
        MOV     RUN_CNT,0       ; Counter for boar runs
        MOV     WORD PTR SCORE_CNT,0     ; Update score count
        MOV     CS:BOAR_OFF,1   ; No display switch
        MOV     CS:FIRST_DUCK,1 ; First duck in line switch
        MOV     CS:NEW_RUN,1    ; Start of a new run
        MOV     CS:ACTIVE_BOAR,'R'      ; Start at right
        MOV     CS:RPIG_X,588   ; Start position for right pig
        MOV     CS:LPIG_X,4     ; Start position for left pig
        MOV     CS:CROSS_X,310
        MOV     CS:CROSS_Y,CUR_LIM_UP
        MOV     CS:GUN_LOADED,0 ; Gun initially unloded
        CALL    KBR_FLUSH       ; Clear old characters from buffer
        CALL    XOR_XHAIR       ; Display crosshair symbol
;**********************|
;    wait for right    |
;    button pressed    |
;**********************|
; This routine allows the player to read last game's score
; until the right mouse button is pressed
; The code also checks for an exit keystroke during this wait
;***************************************************************
;                       start of boar run
;***************************************************************
START_BOAR_RUN:
; Test run number and set PRACTICE/MATCH switch
; Practice runs are 0 to 3 and 19 to 23
; Assume a match run (RUN_SW = 1)
        MOV     RUN_SW,1        ; Match run
        CMP     RUN_CNT,3       ; Test for lower practice range
        JA      TEST_UPRANGE    ; Go if greater than 3
        MOV     RUN_SW,0        ; Set switch for PRACTICE
        JMP     RUNSW_SET
TEST_UPRANGE:
        CMP     RUN_CNT,19      ; Test range limit
        JB      RUNSW_SET       ; Go if less than 20
        CMP     RUN_CNT,22      ; Test limit
        JA      RUNSW_SET       ; Go if MATCH run
        MOV     RUN_SW,0        ; Set switch for PRACTICE
RUNSW_SET:
; Test run number and set SLOW/FAST switch (SPEED_SW)
        MOV     SPEED_SW,0      ; Assume slow run
        CMP     RUN_CNT,19      ; First fast run
        JB      SPEEDSW_SET     ; Go if slow
; Test for first fast run (number 34) and increment boar speed
        MOV     SPEED_SW,1      ; Set for fast
        CMP     RUN_CNT,19      ; First fast run
        JNE     SPEEDSW_SET     ; Go if not run No. 19
; Run number 19 processing
        ADD     CS:BOAR_SPEED,PRIME_SPEED       ; Double speed
                                                ; rate
SPEEDSW_SET:
        CALL    SHOW_STATUS
        CALL    FLUSH_MOUSE     ; Get rid of old button presses
WAIT_4_LOAD:
        CALL    MOUSE_MOVE      ; Move cursor if mouse dragged
        CALL    TEST_4_KEY      ; Test for <Esc> or <F1> pressed
        CALL    TEST_4_LOAD     ; Test for right mouse button
                                ; pressed
; Carry set if button pressed
        JNC     WAIT_4_LOAD     ; Loop if not changed
        MOV     CS:HIT_SW,0     ; Reset hit-miss switch
; Gun is loaded. Delay 2 seconds and start run
        MOV     COM_SW,1        ; FIRE WHEN READY
        MOV     CS:GUN_FIRED,0  ; Reset gun fired switch
; Turn OFF scope, if ON
        CMP     SCOPE_SW,1      ; Is scope ON ?
        JNE     SCOPE_IS_OFF    ; Go if not ON
        MOV     SCOPE_SW,0      ; Change switch
        CALL    SCOPE_OFF       ; Call procedure
SCOPE_IS_OFF:
        CALL    SHOW_STATUS     ; Display match status area
        CALL    RUN_DELAY
;
        MOV     BYTE PTR CS:BOAR_OFF,0   ; Set boar display switch
;**********************|
;      boar run        |
;**********************|
WAIT_4_RUN:
; Routine monitors the BOAR_OFF switch to detect the end of a run
        CALL    MOUSE_MOVE      ; Move mouse if necessary
        CMP     BYTE PTR CS:BOAR_OFF,1   ; End of boar run?
        JNE     WAIT_4_RUN
;**********************|
;   end of boar run    |
;**********************|
; Test for run ending without gun fired
        CMP     CS:GUN_FIRED,1  ; Gun was fired during run ?
        JE      YES_FIRED       ; Go if fired
; Set HIT/MISS switch to miss and clear score variables
        MOV     CS:HIT_SW,0     ; No fired = miss
        MOV     CS:X_VALUE,0            ; Clear score variables
        MOV     CS:Y_VALUE,0
; If run ended due to a hit, delay 1/2 second
YES_FIRED:
        CMP     CS:HIT_SW,1     ; Hit switch on ?
        JNE     NO_HALFSEC      ; Do not delay
        MOV     BX,500          ; 500 milliseconds
        CALL    MILLI_TIME
NO_HALFSEC:
        MOV     CS:NEW_RUN,0    ; Reset new run switch
        INC     RUN_CNT         ; Scoreboard variable
        MOV     THIS_CNT,0      ; Assume shot missed
;**********************|
;  update scoreboard   |
;   and post target    |
;**********************|
        CALL    GET_SCORE       ; Calculate scoring variables
        CALL    SCOREBOARD      ; Update scoreboard display
        MOV     COM_SW,0        ; LOAD ROUND
        MOV     SCOPE_SW,0      ; Set scope off switch
        CALL    SCOPE_OFF       ; Redisplay scope graphics
;**********************|
;   test for end of    |
;        match         |
;**********************|
        CMP     RUN_CNT,TOTAL_RUNS;
        JNE     GAME_OK
        JMP     GAME_OVER       ; Go if end of match
GAME_OK:
        JMP     START_BOAR_RUN  ; Next boar run
;****************************************************************
;                       end of match
;****************************************************************
GAME_OVER:
; Erase last crosshair symbol
        CALL    XOR_XHAIR       ; Erase
        INC     MATCH_CNT       ; Bump counter to next match
        MOV     COM_SW,2        ; LOAD status message
        CALL    SHOW_STATUS     ; Display match status area
;
        LEA     SI,MATCHEND_MS  ; Pointer to end of match message
        LEA     DI,FONT_1X16
        CALL    MULTI_TEXT      ; Procedure in SOLUTION.LIB
;
        CALL    KBR_FLUSH       ; Flush keyboard of old characters
        CALL    KBR_WAIT
;****************************************************************
;                          exit program
;****************************************************************
BOAR_MATCH_EXIT:
        CALL    VRI_OFF         ; Disable vertical retrace
        MOV     CS:BOAR_OFF,1   ; Set boar to no display
;
        MOV     AX,0            ; Reset mouse system
        INT     33H
        CALL    DATA_NORMAL
;
        JMP     START_MAIN
;
;*******************************************************************
;                         INT 0AH handler
;                    vertical retrace interrupt
;*******************************************************************
; The following routine moves the boar one step (4 pixels)
; horizontally. The routine executes at every vertical retrace
; cycle of the CRT controller, which is, approximately 70 times
; per second
;*******************************************************************
HEX0A_INT:
        CLI                     ; Interrupts off
; Save registers
        PUSH    AX              ; Save context at interrupt time
        PUSH    BX
        PUSH    CX
        PUSH    DX
        PUSH    SI
        PUSH    DI
        PUSH    ES
;**********************|
;  activate vertical   |
;  retrace interrupt   |
;**********************|
        MOV     DX,CS:CRT_PORT  ; Recover CRT base address
        IN      AL,DX           ; Get value in CRTC address register
        JMP     SHORT $+2       ; I/O delay
        MOV     CS:AR_BYTE,AL   ; Store value in variable
        MOV     AL,11H          ; Offset of vertical retrace end
                                ; register in the CRTC
        MOV     AH,CS:OLD_VRE
                                ; Default value in vertical retrace
                                ; end register
        AND     AH,11101111B    ; Clear bit 5 in VRE register
                                ; Bit 5 = enable vertical retrace
        OUT     DX,AX           ; To port
        JMP     SHORT $+2       ; I/O delay
;**********************|
;     test for duck    |
;   display suspended  |
;**********************|
        CMP     CS:BOAR_OFF,1   ; No boar display
        JNE     SHOW_DUCK       ; Display duck if switch off
        JMP     EXIT_DUCKY
;**********************|
;   ES to video base   |
;**********************|
SHOW_DUCK:
        MOV     AX,0A000H       ; EGA/VGA systems base address
        MOV     ES,AX           ; to ES
;**********************|
;    display left or   |
;       right boar     |
;**********************|
        CMP     CS:ACTIVE_BOAR,'R' ; Test for right starting boar
        JE      RIGHT_BOAR
;
;*****************************************************************
;                        left boar action
;*****************************************************************
LEFT_BOAR:
; Test for gun fired
        CMP     CS:GUN_FIRED,1  ; Was gun fired ?
        JE      LEFT_BOAR_OFF
; Test for screen limit
        CMP     WORD PTR CS:LPIG_X,587
                                ; Right side limit of left pig
        JB      LBOAR_DISPLAY   ; Display if less
;**********************|
;   start right boar   |
;**********************|
LEFT_BOAR_OFF:
        CALL    XOR_LBOAR       ; Erase last left boar
        MOV     BYTE PTR CS:FIRST_DUCK,1 ; Set first duck switch
        MOV     CS:RPIG_X,588   ; Duck back to right screen side
        MOV     CS:ACTIVE_BOAR,'R'      ; Right boar on
        MOV     CS:BOAR_OFF,1   ; No boar display switch
        MOV     CS:NEW_RUN,1    ; Start new run
        JMP     EXIT_DUCKY
LBOAR_DISPLAY:
        CMP     BYTE PTR CS:FIRST_DUCK,1
        JE      LBOAR_ON        ; Turn on boar
        CALL    XOR_LBOAR
        MOV     AL,CS:BOAR_SPEED        ; Speed to register
        MOV     AH,0
        ADD     CS:LPIG_X,AX    ; Add value to coordinate
        CALL    XOR_LBOAR       ; Display new cursor
        JMP     EXIT_DUCKY
LBOAR_ON:
        CALL    XOR_LBOAR
        MOV     BYTE PTR CS:FIRST_DUCK,0 ; Turn off switch
        JMP     EXIT_DUCKY
;
;*****************************************************************
;                       right boar action
;*****************************************************************
; Test for zero x coordinate
RIGHT_BOAR:
; Test for gun fired
        CMP     CS:GUN_FIRED,1  ; Was gun fired ?
        JE      RIGHT_BOAR_OFF
        CMP             WORD PTR CS:RPIG_X,5
                        ; Left side limit of right pig
        JA      RBOAR_DISPLAY
;**********************|
;   start left boar    |
;**********************|
RIGHT_BOAR_OFF:
        CALL    XOR_RBOAR       ; Erase right boar
        MOV     BYTE PTR CS:FIRST_DUCK,1 ; Set first duck switch
        MOV     CS:LPIG_X,4     ; Boar x coordinate at screen left
        MOV     CS:ACTIVE_BOAR,'L'      ; Left boar on
        MOV     CS:BOAR_OFF,1   ; No boar display switch
        MOV     CS:NEW_RUN,1    ; Start new run
        JMP     EXIT_DUCKY
RBOAR_DISPLAY:
        CMP     BYTE PTR CS:FIRST_DUCK,1
        JE      RBOAR_ON        ; Turn on boar
        CALL    XOR_RBOAR
        MOV     AL,CS:BOAR_SPEED        ; Speed to register
        MOV     AH,0
        SUB     CS:RPIG_X,AX    ; Subtract from coordinate
        CALL    XOR_RBOAR
        JMP     EXIT_DUCKY
RBOAR_ON:
        CALL    XOR_RBOAR
        MOV     BYTE PTR CS:FIRST_DUCK,0 ; Turn off switch
;**********************|
; exit service routine |
;**********************|
EXIT_DUCKY:
; Enable 8259 interrupt controller to receive other interrupts
        MOV     AL,20H          ; Port address
        OUT     20H,AL          ; Send EOI code
        JMP     SHORT $+2
;
        MOV     DX,CS:CRT_PORT  ; Recover CRT base address
        MOV     AL,11H          ; Offset of vertical retrace end
                                ; register in the CRTC
        MOV     AH,CS:OLD_VRE
                                ; Default value in vertical retrace
                                ; end register
        AND     AH,11011111B    ; Clear bits 4 and 5 in VRE register
                                ; Bit 4 = clear vertical interrupt
                                ; Bit 5 = enable vertical retrace
        OR      AH,00010000B    ; Make sure bit 5 is clear
        OUT     DX,AX           ; To port
        JMP     SHORT $+2       ; I/O delay
        MOV     AL,CS:AR_BYTE   ; Recover initial setting
        OUT     DX,AL           ; in address register
        JMP     SHORT $+2
;**********************|
;   restore context    |
;**********************|
        POP     ES
        POP     DI
        POP     SI
        POP     DX
        POP     CX
        POP     BX
        POP     AX
        STI                     ; Re-enable interrupts
        IRET
;
;**********************|
;  display procedures  |
;**********************|
XOR_RBOAR       PROC    NEAR
; This procedure displays and erases the right boar
        LEA     SI,CS:RPIG_X
        LEA     BX,CS:BOAR_COLOR 
        CALL    VARI_MAP        ; Display procedure
        RET
XOR_RBOAR       ENDP
;
XOR_LBOAR       PROC    NEAR
; This procedure displays and erases the left boar
        LEA     SI,CS:LPIG_X
        LEA     BX,CS:BOAR_COLOR 
        CALL    VARI_MAP        ; Display procedure
        RET
XOR_LBOAR       ENDP
;
;*******************************************************************
;                         code segment data                         
;*******************************************************************
;**********************|
;   parameter storage  |
;**********************|
OLD_VECTOR_0A   DD      0       ; Pointer to original INT 0AH
                                ; interrupt
CRT_PORT        DW      0       ; Address of CRT controller
AR_BYTE         DB      0       ; Value in CRT address register
                DB      0
OLD_VRE         DB      0
                DB      0
;**********************|
; operational variables|
;**********************|
HIT_SW          DB      0       ; Hit or miss switch
                DB      0       ; 1 = hit
; Used by the VARI_MAP procedures
X_COORD         DW      0000H   ; Storage for x coordinate
BYTES           DB      0H      ; Number of bytes per block row
                DB      0
COUNT_8         DB      8       ; Bit counter for the VARI_PATTERN
                DB      0       ; procedure
GUN_LOADED      DB      0       ; Gun loaded switch
        DB      0               ; set by right mouse button
GUN_FIRED       DB      0       ; Set to 1 if gun was fired
; Scoring variables
X_VALUE         DB      0
Y_VALUE         DB      0
;**********************|
;   graphic blocks     |
;*********************|
; For XORing with 00001000B (GRAY background)
; 0 -------> 0000B = 0H (pixel is unchanged)
; w -------> 1111B = FH (pixel is white)
; r -------> 1100B = CH (pixel is red)
;
; Block control area:                      Displacement -->
CROSS_X DW      310         ; Present x coordinate         0
                            ; range = 0 to 630
CROSS_Y DW      360         ; Present y coordinate         2
                            ; range = 360 to 460
        DB      15          ; Horizontal rows in block     4
        DB      2           ; Number of bytes per row      5
;
; Symbol encoding of crosshair symbol
        DB      00FH,0E0H
        DB      011H,010H
        DB      021H,008H
        DB      041H,004H
        DB      081H,002H
        DB      081H,002H
        DB      081H,002H
        DB      0FFH,0FEH
        DB      081H,002H
        DB      081H,002H
        DB      081H,002H
        DB      041H,004H
        DB      021H,008H
        DB      011H,010H
        DB      00FH,0E0H
        DW      0000H       ; Safety padding
;
; Color encoding of crosshair symbol
CR_COL  DB      00001111B       ; I R G B code
        DB      0
;
;****************************|
;    right-to-left boar      |
;****************************|
; Block control area:                      Displacement -->
RPIG_X  DW      588         ; Present x coordinate         0
RPIG_Y  DW      440         ; y coordinate                 2
        DB      19          ; Horizontal rows in block     4
        DB      6           ; Number of bytes per row      5
;
; Symbol encoding for right-hand boar
        DB      000H,00FH,0FFH,0F0H,001H,0F8H ; 1
        DB      000H,070H,081H,00FH,0C2H,000H ; 2
        DB      000H,081H,0BCH,080H,03CH,000H ; 3
        DB      003H,002H,042H,040H,002H,000H ; 4
        DB      00CH,004H,099H,020H,002H,000H ; 5
        DB      030H,005H,024H,0A0H,001H,000H ; 6
        DB      0C0H,005H,05AH,0A0H,001H,000H ; 7
        DB      080H,005H,05AH,0A0H,001H,000H ; 8
        DB      078H,005H,024H,0A0H,000H,0E0H ; 9
        DB      006H,004H,099H,020H,000H,010H ; 10
        DB      001H,0E2H,042H,040H,000H,010H ; 11
        DB      000H,011H,0BCH,080H,000H,008H ; 12
        DB      001H,0E0H,081H,000H,000H,014H ; 13
        DB      002H,000H,07EH,00FH,083H,0EAH ; 14
        DB      00DH,000H,03FH,0F0H,07CH,037H ; 15
        DB      006H,086H,040H,000H,000H,028H ; 16
        DB      000H,099H,080H,000H,000H,024H ; 17
        DB      001H,060H,000H,000H,000H,01EH ; 18
        DB      003H,080H,000H,000H,000H,000H ; 19
        DW      0000H
        DW      0000H
;
;****************************|
;    left-to-right boar      |
;****************************|
; Block control area:                           Displacement -->
LPIG_X  DW      4           ; Present x coordinate         0
LPIG_Y  DW      440         ; y coordinate                 2
        DB      19          ; Horizontal rows in block     4
        DB      6           ; Number of bytes per row      5
;
; Symbol encoding for left-hand boar
        DB      01FH,080H,00FH,0FFH,0F0H,000H ; 1
        DB      000H,043H,0F0H,081H,00EH,000H ; 2
        DB      000H,03CH,001H,03CH,081H,000H ; 3
        DB      000H,040H,002H,042H,040H,0C0H ; 4
        DB      000H,040H,004H,099H,020H,030H ; 5
        DB      000H,080H,005H,024H,0A0H,00CH ; 6
        DB      000H,080H,005H,05AH,0A0H,003H ; 7
        DB      000H,080H,005H,05AH,0A0H,001H ; 8
        DB      007H,000H,005H,024H,0A0H,01EH ; 9
        DB      008H,000H,004H,099H,020H,060H ; 10
        DB      008H,000H,002H,042H,047H,080H ; 11
        DB      010H,000H,001H,03CH,088H,000H ; 12
        DB      028H,000H,000H,081H,007H,080H ; 13
        DB      05FH,0C1H,0F0H,03FH,000H,040H ; 14
        DB      0FCH,03EH,00FH,0FCH,000H,0B0H ; 15
        DB      014H,000H,000H,002H,061H,060H ; 16
        DB      024H,000H,000H,001H,099H,000H ; 17
        DB      078H,000H,000H,000H,006H,080H ; 18
        DB      000H,000H,000H,000H,001H,0C0H ; 19
        DW      0000H
        DW      0000H
;
; Color code for both boars
BOAR_SPEED      DB      2       ; 2 = slow rate
                                ; 4 = fast rate
BOAR_COLOR      DB      00000100B       ; R on
                DB      00H             ; Padding
;
ACTIVE_BOAR     DB      'R'     ; Left or right boar display
                DB      0       ; control
;
FIRST_DUCK      DB      1       ; Switch for first iteration
                DB      0
BOAR_OFF        DB      1       ; No boar displayed
                DB      0
NEW_RUN         DB      0       ; Set when a new run direction
                DB      0       ; is engaged
;
;****************************|
;           grass            |
;****************************|
; Block control area:                           Displacement -->
GRASS_X DW      0           ; Present x coordinate         0
GRASS_Y DW      455         ; y coordinate                 2
        DB      10          ; Horizontal rows in block     4
        DB      4           ; Number of bytes per row      5
;
; Symbol encoding for grass
        DB      010H,081H,004H,011H ; 1
        DB      012H,081H,005H,011H ; 2
        DB      036H,0C4H,085H,011H ; 3
        DB      036H,06CH,0ADH,031H ; 4
        DB      076H,06DH,0ADH,0B3H ; 5
        DB      066H,06DH,0ADH,0BBH ; 6
        DB      06EH,06DH,0EDH,0BBH ; 7
        DB      06EH,0E7H,0EFH,0FBH ; 8
        DB      0FFH,0FFH,0FFH,0FFH ; 9
        DB      0FFH,0FFH,0FFH,0FFH ; 10
        DW      0000H
GRASS_COLOR     DB      00000010B       ; G on
                DB      00H             ; Padding
;
CODE_1  ENDS
        END

S_COLOR     DB      00000010B       ; G on
                DB      00H             ; Padding
;
CODE_