$ NOPRINT ERRORPRINT
NAME MATCH1A
;*******************************************************************
;*******************************************************************
;                            MATCHD.ASM
;                       running target match
;                        support routines (1)
;*******************************************************************
;*******************************************************************
;
;*******************************************************************
;                          p u b l i c s 
;*******************************************************************
PUBLIC  MOVE_CURSOR
PUBLIC  UPDATE_X
PUBLIC  UPDATE_Y
PUBLIC  XOR_XHAIR
PUBLIC  SCOREBOARD
PUBLIC  GET_SCORE
PUBLIC  MOVE_CX_DIGS
PUBLIC  SCOPE_ON
PUBLIC  MOUSE_MOVE
PUBLIC  TEST_4_KEY
PUBLIC  FLUSH_MOUSE
PUBLIC  TEST_4_LOAD
PUBLIC  RUN_DELAY
PUBLIC  SHOW_STATUS
PUBLIC  SCORE_LINE
PUBLIC  VARI_MAP
PUBLIC  ORIGIN_X
PUBLIC  BRESENHAM
PUBLIC  ORIGIN_Y
PUBLIC  END_X
PUBLIC  END_Y
PUBLIC  LINE_COLOR
PUBLIC  SCOPE_SW
;
;*******************************************************************
;                         e x t e r n a l s 
;*******************************************************************
; Externals from SOLUTIONS.LIB
EXTRN   KBR_FLUSH:      FAR
EXTRN   KBR_STATUS:     FAR
EXTRN   KBR_WAIT:       FAR
EXTRN   SOUND:          FAR
EXTRN   RANDOM_NUM:     FAR
EXTRN   BIN_TO_ASC:     FAR
EXTRN   BIO_SET_MODE:   FAR
EXTRN   TIME_VRC:       FAR
EXTRN   COARSE_FILL:    FAR
EXTRN   COARSE_ADD:     FAR
EXTRN   SET_WRITE_MODE: FAR
EXTRN   DATA_XOR:       FAR
EXTRN   DATA_NORMAL:    FAR
EXTRN   START_MAIN:     FAR
EXTRN   MILLI_TIME:     FAR
EXTRN   PIXEL_ADD:      FAR
EXTRN   WRITE_PIX:      FAR
EXTRN   FINE_TEXT:      FAR
EXTRN   COARSE_TEXT:    FAR
EXTRN   MULTI_TEXT:     FAR
EXTRN   SHOW_TIFF:      FAR
;
; External equates
EXTRN   TOTAL_RUNS:     ABS
EXTRN   ON_X:           ABS
EXTRN   ON_Y:           ABS
;
;**************************** equates ******************************
; Limits of cursor movement
; The following values limit the movement of the crosshair symbol
; to the gray rectangular area
CUR_LIM_RIGHT   EQU     620
CUR_LIM_LEFT    EQU     5
CUR_LIM_UP      EQU     362
CUR_LIM_DOWN    EQU     454
;
; Number of rounds in match
MATCH_ROUNDS    EQU     10
;
; The following value determines the speed at which the boar travels
; across the screen. Increasing this value will make the boar
; travel faster
BOAR_SPEED      EQU     4
;
;*****************************************************************
;                               data
;*****************************************************************
DATA    SEGMENT BYTE    PUBLIC
;**********************|
;      DS externals    |
;**********************|
EXTRN   RUN_CNT:        BYTE
EXTRN   MATCH_CNT:      BYTE
EXTRN   NUM_BUFFER:     BYTE
EXTRN   SCORE_CNT:      WORD
EXTRN   THIS_CNT:       BYTE
EXTRN   FONT_1X16:      BYTE
EXTRN   FONT_1X8:       BYTE
EXTRN   RUN_SW:         BYTE
EXTRN   TIMER_COUNT:    WORD
EXTRN   COM_SW:         BYTE
EXTRN   SPEED_SW:       BYTE
;
;
ROUND_EVEN      DW      13FFH   ; Round to even (default)
ROUND_DOWN      DW      17FFH
; Scoring variables
X_QUAD4         DW      0
Y_QUAD4         DW      0
DIST_2_EYE      DW      0       ; Calculated distance to
                                ; target bullseye
; Origin coordinates for curve display
ORIGIN_X        DW      0   ; x coordinate of origin
ORIGIN_Y        DW      0   ; y coordinate of origin
;
; Variables for curve computations
; Circle:
R               DW      0   ; Radius in pixels
;
;-------------------|
;    scratch pad    |
;     variables     |
;-------------------|
THIS_X          DW      0   ; Absolute coordinate of x
THIS_Y          DW      0   ; Absolute coordinate of y
LAST_Y          DW      0   ; Internal control for
                            ; noncontinuous y axis points
OPS_CNT         DW      0   ; Operational points counter
                            ; for circle display procedures
;
; Storage for BRESENHAM line display routine
END_X           DW      0H  ; x coordinate of end point
END_Y           DW      0H  ; y coordinate of end point
;
LINE_COLOR      DB      0H  ; Color
;
INCR_FOR_X      DW      ?   ; Positive or negative direction
                            ; for x axis increments
INCR_FOR_Y      DW      ?   ; Idem for y axis increments
;
STRT_HSEGS      DW      ?   ; 1 if straight segments are
                            ; horizontal; zero otherwise
STRT_VSEGS      DW      ?   ; 1 if straight segments are
                            ; vertical; zero otherwise
STRT_TOTAL      DW      ?   ; Straight pixels
DIAG_TOTAL      DW      ?   ; Diagonal pixels
;
;-------------------|
;     buffers       |
;and buffer controls|
;-------------------|
; Buffers for storing 1K of x,y coordinates of the first quadrant
; and counter for the number of points computed
Y_BUFFER        DB      2048 DUP (00H)
X_BUFFER        DB      2048 DUP (00H)
POINTS_CNT      DW      0   ; Number of entries in buffers
;
;**********************|
;   other switches     |
;**********************|
SCOPE_SW        DB      0       ; 0 = spotting scope OFF
                                ; 1 = spotting scope ON
;
;**********************|
;    text messages     |
;**********************|
; Graphic block message for the words Shooting GALLERY
DIGITS1 DW      30      ; Start x coordinate
        DW      94      ; Start y coordinate
        DW      6       ; Pixel spacing on x axis
        DW      6       ; Pixel spacing on y axis
        DB      00000100B       ; I R G B color code
        DB      '123',0H
DIGITS2 DW      47
        DW      111
        DW      6
        DW      6
        DB      00000100B
        DB      '456',0H
DIGITS3 DW      64
        DW      128
        DW      6
        DW      6
        DB      00000100B
        DB      '789',0H
DIGITS4 DW      81
        DW      146
        DW      6
        DW      0
        DB      00000100B
        DB      '10',00H
DIGITS5 DW      94      ; Start x coordinate
        DW      154     ; Start y coordinate
        DW      6       ; Pixel spacing on x axis
        DW      6       ; Pixel spacing on y axis
        DB      00000100B       ; I R G B color code
        DB      '987',0H
DIGITS6 DW      111
        DW      171
        DW      6
        DW      6
        DB      00000100B
        DB      '654',0H
DIGITS7 DW      128
        DW      188
        DW      6
        DW      6
        DB      00000100B
        DB      '321',0H
;
DIGITS8 DW      30
        DW      200
        DW      6
        DW      -6
        DB      00000100B
        DB      '123',0H
DIGITS9 DW      47
        DW      183
        DW      6
        DW      -6
        DB      00000100B
        DB      '456',0H
DIGITS10        DW      64
        DW      166
        DW      6
        DW      -6
        DB      00000100B
        DB      '789',0H
DIGITS11        DW      94
        DW      140
        DW      6
        DW      -6
        DB      00000100B
        DB      '987',0H
DIGITS12        DW      111
        DW      123
        DW      6
        DW      -6
        DB      00000100B
        DB      '654',0H
DIGITS13        DW      128
        DW      106
        DW      6
        DW      -6
        DB      00000100B
        DB      '321',0H
;
;**********************|
;  match status text   |
;**********************|
; Text message and graphics displayed at the status area
STAT_MS         DW      8
        DW      278
        DW      8
        DW      18
        DB      00001111B
        DB      ' COMMAND:',0FFH
        DB      ' NEXT RUN TYPE:',0FFH
        DB      ' NEXT RUN SPEED:',00H
;
COM0_LN DW      88
        DW      278
        DW      8
        DW      0
        DB      00001100B
        DB      'L O A D',00H
;
COM1_LN DW      88
        DW      278
        DW      8
        DW      0
        DB      00001100B
        DB      'F I R E  W H E N  R E A D Y',00H
;
COM2_LN DW      88
        DW      278
        DW      8
        DW      0
        DB      00001100B
        DB      'C E A S E  F I R I N G',00H
;
;**********************|
; run status messages  |
;**********************|
RUN0_LN DW      140
        DW      296
        DW      8
        DW      0
        DB      00001100B
        DB      'P R A C T I C E',00H
;
RUN1_LN DW      140
        DW      296
        DW      8
        DW      0
        DB      00001100B
        DB      'M A T C H',00H
;
;**********************|
; speed status messages|
;**********************|
SPEED0_LN       DW      145
        DW      314
        DW      8
        DW      0
        DB      00001100B
        DB      'S L O W',00H
;
SPEED1_LN       DW      145
        DW      314
        DW      8
        DW      0
        DB      00001100B
        DB      ' F A S T ',00H
;
;**********************|
; scoreboard data line |
;**********************|
; This text line is refreshed by the different courses
DATA_LN DB      42
        DB      20
        DB      00001111B
                DB      20H,0BAH,20H,20H
MATCH_NUM       DB      ' 1',20H,20H,20H,0BAH,20H
RUN_NUM         DB      ' 0/38 ',0BAH,20H
LAST_SCORE      DB      ' 0/10',020H,0BAH,20H
TOTAL_POINTS    DB      '  0/300',20H,0BAH,00H
;
;**********************|
;    TIFF image for    |
;       target         |
;**********************|
; Encoding of graphics for mouse drawing
CIRCLE_IMAGE    DW      3           ; Present x coordinate         0
                DW      67          ; Present y coordinate         2
                DW      174     ; Offset of bit map in TIFF file
                DW      168     ; Pixel rows in image
                DB      22      ; Bytes per row
                DB      00000100B       ; I R G B CODE
                DB      'CIR1R.TIF',00H
                DB      5 DUP (00H)     ; Padding
;
;
DATA    ENDS
;
;*****************************************************************
;                               code
;*****************************************************************
CODE_1  SEGMENT BYTE   PUBLIC
        ASSUME  CS:CODE_1,DS:DATA
;**********************|
;     CS  externals    |
;**********************|
EXTRN   BOAR_MATCH_EXIT:        NEAR
;
EXTRN   HIT_SW:         BYTE
EXTRN   COUNT_8:        BYTE
EXTRN   BYTES:          BYTE
EXTRN   X_COORD:        WORD
EXTRN   X_VALUE:        BYTE
EXTRN   Y_VALUE:        BYTE
EXTRN   CROSS_X:        WORD
EXTRN   CROSS_Y:        WORD
EXTRN   GUN_LOADED:     BYTE
EXTRN   CR_COL:         BYTE
EXTRN   SCOPE_OFF:      NEAR
EXTRN   VRI_OFF:        NEAR
;
;*******************************************************************
;                            procedures
;*******************************************************************
BRESENHAM       PROC    NEAR
; Procedure to draw a straight line with starting coordinates
; stored at ORIGIN_X and ORIGIN_Y and end coordinates at END_X
; and END_Y. Color for line must be in the variable LINE_COLOR
; Uses Bresenham's Algorithm
;
; Set unit increments for pixel to pixel space
        MOV     CX,1
        MOV     DX,1
; Determine negative or positive slope from difference between
; the y,x coordinates of the start and end of the line. This
; difference is also the length of the line
        MOV     DI,END_Y
        SUB     DI,ORIGIN_Y ; Length
        JGE     POS_VERTICAL    ; Vertical length is positive
        NEG     DX          ; DX = -1 in 2's complement form
        NEG     DI          ; Make distance positive
;
POS_VERTICAL:
        MOV     INCR_FOR_Y,DX   ; Increments on the y axis will
                            ; be positive or negative
; Calculate horizontal distance
        MOV     SI,END_X
        SUB     SI,ORIGIN_X
        JGE     POS_HORZ    ; Horizontal length is positive
        NEG     CX          ; CX = -1 in 2's complement form
        NEG     SI          ; Distance has to be positive
;
POS_HORZ:
        MOV     INCR_FOR_X,CX   ; Increments on the x axis can 
                            ; also be positive or negative
;
; Compare the horizontal and vertical lengths of the line to
; determine if the straight segments will be horizontal (if
; this length is greater) or vertical (otherwise)
        CMP     SI,DI       ; SI = horizontal length
                            ; DI = vertical length
        JGE     HORZ_SEGMENTS
; Vertical length is greater, straight segments are vertical
        MOV     CX,0        ; No horizontal segments
        XCHG    SI,DI       ; Invert lengths
        JMP     SET_CONTROLS
;
HORZ_SEGMENTS:
        MOV     DX,0        ; No vertical segments
;
SET_CONTROLS:
        MOV     STRT_HSEGS,CX   ; Will be 1 or 0
        MOV     STRT_VSEGS,DX   ; Also 1 or 0
; Calculate adjustment factor
        MOV     AX,DI           ; Smaller direction component
        ADD     AX,AX           ; Double the shorter distance
        MOV     STRT_TOTAL,AX   ; Straight component total pixs
        SUB     AX,SI           ; Subtract larger direction
                                ; component
        MOV     BX,AX           ; General component counter
        SUB     AX,SI           ; Calculate
        MOV     DIAG_TOTAL,AX   ; Diagonal component total pixs
; Prepare to draw line
        MOV     CX,ORIGIN_X
        MOV     DX,ORIGIN_Y
; SI = the length of the line along the longer axis
        INC     SI
        MOV     AL,LINE_COLOR   ; Color code for line
;
;-----------------|
; draw line points|
;-----------------|
LINE_POINTS:
        DEC     SI          ; Counter for total pixs
        JNZ     PIX_DRAW
        RET
;
;-----------------|
; display pixel   |
;-----------------|
PIX_DRAW:
        CALL    PIXEL_WRITE
;
        CMP     BX,0        ; If BX < 0 then straight segment
                            ; diagonal segment otherwise
        JGE     DIAGONAL
;-----------------|
; straight segs.  |
;-----------------|
        ADD     CX,STRT_HSEGS   ; Increment CX if segment is
                                ; horizontal
        ADD     DX,STRT_VSEGS   ; Increment DX if segment is
                                ; vertical
        ADD     BX,STRT_TOTAL   ; Counter plus adjustment
        JMP     LINE_POINTS
;
;-----------------|
; diagonal segs.  |
;-----------------|
DIAGONAL:
        ADD     CX,INCR_FOR_X   ; X direction
        ADD     DX,INCR_FOR_Y   ; Y direction
        ADD     BX,DIAG_TOTAL   ; Adjust counter
        JMP     LINE_POINTS
;
BRESENHAM       ENDP
;*****************************************************************
;
SCORE_LINE      PROC    NEAR
; Move text line for current course into the scoreboard display
; line
; On entry:
;         DS:SI ==> customized scoreboard line
;
        MOV     CX,39           ; Characters to move
        LEA     DI,DATA_LN      ; Destination buffer
MOVE_36:
        MOV     AL,[SI]         ; Get character from source
        MOV     [DI],AL         ; Place in destination buffer
        INC     SI              ; Bump pointers
        INC     DI
        LOOP    MOVE_36
        RET
SCORE_LINE      ENDP
;*****************************************************************
;
MOVE_CURSOR     PROC    NEAR
; Erase old cursor and reposition cross hair according to mouse
; movement detected
; Units are in mickeys (1 mickey = 1/200 in.)
; If CH high bit set then horizontal movement is left
; If DH high bit set then vertical movement is up
        CALL    XOR_XHAIR       ; Erase old cross hair
        CMP     CX,0            ; Test for no x-axis movement
        JE      NO_HORZ         ; No horizontal move if CX zero
        CALL    UPDATE_X        ; Update horizontal position
NO_HORZ:
        CMP     DX,0
        JE      NO_VERT         ; Test for vertical movement
        CALL    UPDATE_Y        ; Update vertical position
NO_VERT:
        CALL    XOR_XHAIR       ; Re-display cursor
        RET
MOVE_CURSOR     ENDP
;*******************************************************************
;
UPDATE_X        PROC    NEAR
; Update counter CROSS_X with value in CL testing for limits
; CH high bit set if mouse movement was left
        TEST    CH,10000000B    ; Decrement counter if high bit set
        JNZ     X_COUNT_DOWN    ; Go if bit set
; Increment counter in loop. Cursor movement is right
X_RIGHT:
        CMP     CS:CROSS_X,CUR_LIM_RIGHT
                                ; Equate for right hand limit
        JA      NO_RIGHT_X      ; No right movement
        INC     CS:CROSS_X      ; Bump counter if not at limit
        LOOP    X_RIGHT
NO_RIGHT_X:
        RET
; Decrement horizontal position
X_COUNT_DOWN:
        MOV     CH,0            ; Clear high byte of counter
        NOT     CL              ; Convert two's complement value
        INC     CL              ; to unsigned binary
X_LEFT:
        CMP     CS:CROSS_X,CUR_LIM_LEFT
                                ; Equate for left hand limit
        JB      NO_LEFT
        DEC     CS:CROSS_X      ; Decrement counter
        LOOP    X_LEFT
NO_LEFT:
        RET
UPDATE_X        ENDP
;*******************************************************************
;
UPDATE_Y        PROC    NEAR
; Update counter CROSS_Y with value in DL testing for limits
; CH high bit set if mouse movement was up
        XCHG    DX,CX           ; Move value to CX
        TEST    CH,10000000B    ; Decrement counter if high bit set
        JNZ     Y_COUNT_DOWN
; Increment counter in loop. Cursor movement is down
Y_DOWN:
        CMP     CS:CROSS_Y,CUR_LIM_DOWN
                                ; Equate for bottom limit of move
        JA      NO_DOWN_Y       ; No down movement of cursor
        INC     CS:CROSS_Y      ; Bump counter if not at limit
        LOOP    Y_DOWN
NO_DOWN_Y:
        RET
; Decrement counter to move cursor up
Y_COUNT_DOWN:
        MOV     CH,0            ; Clear high byte of counter
        NOT     CL              ; Convert two's complement value
        INC     CL              ; to unsigned binary
Y_UP:
        CMP     CS:CROSS_Y,CUR_LIM_UP
                                ; Equate for left hand limit
        JB      NO_UP
        DEC     CS:CROSS_Y      ; Decrement counter
        LOOP    Y_UP
NO_UP:
        RET
UPDATE_Y        ENDP
;*****************************************************************
;
XOR_XHAIR       PROC    NEAR
; Xor crosshair symbol. If symbol displayed, erase, and vice versa
        CLI                     ; Interrupts off
        PUSH    CX              ; Save mickey registers
        PUSH    DX
        LEA     SI,CS:CROSS_X   ; Offset of display block
        LEA     BX,CS:CR_COL    ; Offset of color table
        CALL    TIME_VRC        ; Time display with vertical retrace
        CALL    VARI_MAP        ; Display routine
        STI                     ; Interrupts on
        POP     DX              ; Restore mickey count
        POP     CX
        RET
XOR_XHAIR       ENDP
;*******************************************************************
;
SCOREBOARD      PROC    NEAR
; Update program's scoreboard using the values in the variables
; Update display
        CALL    DATA_NORMAL
; Draw blue strip to erase old data
        MOV     CH,41           ; Column
        MOV     CL,40           ; Row
        MOV     DH,39           ; Horzontal bytes
        MOV     DL,2            ; Vertical bytes
        MOV     AL,00000001B    ; Blue
        CALL    COARSE_FILL
;
        LEA     SI,DATA_LN      ; Scoreboard variable text line
        LEA     DI,FONT_1X16
        CALL    COARSE_TEXT
;
        CALL    DATA_XOR
        RET
SCOREBOARD      ENDP
;*******************************************************************
;
GET_SCORE       PROC    NEAR
; Calculate scoreboard variables and set ASCII digits in display
; buffer
; Scoreboard display:
;                MATCH     RUN      LAST     TOTAL
;                NUMBER    NUMBER   SCORE    POINTS
;               |-------|---------|--------|---------|
;               |   1   |    1    |    0   |    0    |
;               |-------|---------|--------|---------|
;
; Fill-in MATCH NUMBER
        MOV     DL,MATCH_CNT    ; Binary match counter
        MOV     DH,0            ; Clear high byte
        LEA     DI,NUM_BUFFER   ; Buffer for 5 digits
        CALL    BIN_TO_ASC      ; SOLUTION.LIB conversion procedure
; Buffer holds 2 valid ASCII digits. DI --> start of buffer
        XCHG    SI,DI           ; Invert SI and DI
        ADD     SI,3            ; Point to first significant digit
        LEA     DI,MATCH_NUM    ; Point to destination
        MOV     CX,2            ; Number of digits to move
        CALL    MOVE_CX_DIGS    ; Auxiliary procedure
;
; Fill-in RUN NUMBER
        MOV     DL,RUN_CNT      ; Number of this run
        MOV     DH,0
        LEA     DI,NUM_BUFFER   ; Buffer for 5 digits
        CALL    BIN_TO_ASC      ; SOLUTION.LIB conversion procedure
; Buffer holds 2 valid ASCII digits. DI --> start of buffer
        XCHG    SI,DI           ; Invert SI and DI
        ADD     SI,3            ; Point to first significant digit
        LEA     DI,RUN_NUM      ; Point to destination
        MOV     CX,2            ; Number of digits to move
        CALL    MOVE_CX_DIGS    ; Auxiliary procedure
;
; Get last score
        CALL    SCORE_SHOT      ; Local procedure
        MOV     THIS_CNT,DL     ; Store in DS variable
; Fill-in LAST SCORE
        MOV     DH,0            ; Clear high byte
        LEA     DI,NUM_BUFFER   ; Buffer for 5 digits
        CALL    BIN_TO_ASC      ; SOLUTION.LIB conversion procedure
; Buffer holds 2 valid ASCII digits. DI --> start of buffer
        XCHG    SI,DI           ; Invert SI and DI
        ADD     SI,3            ; Point to first significant digit
        LEA     DI,LAST_SCORE   ; Point to destination
        MOV     CX,2            ; Number of digits to move
        CALL    MOVE_CX_DIGS    ; Auxiliary procedure
;
; Fill-in TOTAL POINTS
; Test for a MATCH run
        CMP     RUN_SW,1        ; Is this a match run
        JNE     NO_TOTAL        ; Go if not a match run
        MOV     DX,WORD PTR SCORE_CNT    ; Binary score counter
        MOV     AL,THIS_CNT     ; Score for last run
        MOV     AH,0            ; Clear high byte
        ADD     DX,AX           ; Add score from this run
        MOV     SCORE_CNT,DX    ; Store accumulated score
        LEA     DI,NUM_BUFFER   ; Buffer for 5 digits
        CALL    BIN_TO_ASC      ; SOLUTION.LIB conversion procedure
; Buffer holds 2 valid ASCII digits. DI --> start of buffer
        XCHG    SI,DI           ; Invert SI and DI
        ADD     SI,2            ; Point to first significant digit
        LEA     DI,TOTAL_POINTS ; Point to destination
        MOV     CX,3            ; Number of digits to move
        CALL    MOVE_CX_DIGS    ; Auxiliary procedure
;
NO_TOTAL:
        RET
GET_SCORE       ENDP
;*****************************************************************
;
SCORE_SHOT      PROC    NEAR
; Score last shot according to values stored in variables
; X_VALUE and Y_VALUE (range 0 to 20)
; Score is determined by calculating the hypotenuse of a triangle
; with x and y sides and subtracting from 10
;
; On exit:
;        DX = binary score
;**********************|
;    reduce to II      |
;      quadrant        |
;**********************|
;            0,0                 |                    20,0
;                                |
;                                |
;                   IV           |           I
;                                |
;                                |
;                                |
;            --------------------|----------------------
;                                |10,10
;                                |
;                                |
;                   III          |           II
;                                |
;                                |
;             0,20               |                    20,20
;
; CASE 1 - If coordinate < 10 then increment and subtract from 10
; CASE 2 - If coordinate > 10 then subtract 10
; Values in X_VALUE and Y_VALUE
;
HIT_SHOT:
        MOV     BL,CS:X_VALUE   ; x coordinate to BH
        CMP     BL,10           ; Test for limit
        JB      CASE1_X         ; x coordinate is in range
                                ; if x <= ON_X
; Subtract constant to scale
        SUB     BL,10
        JMP     SAVE_X
CASE1_X:
        INC     BL              ; Adjust
        MOV     BH,10           ; Constant
        SUB     BH,BL
        MOV     BL,BH           ; x is in BL
SAVE_X:
        MOV     BH,0            ; Clear high byte
        MOV     X_QUAD4,BX      ; Store x in memory
;
        MOV     BL,CS:Y_VALUE   ; y coordinate
        CMP     BL,10           ; Test for limit
        JB      CASE1_Y         ; x coordinate is in range
                                ; if x <= ON_X
; Subtract constant to scale
        SUB     BL,10
        JMP     SAVE_Y
CASE1_Y:
        INC     BL
        MOV     BH,10           ; Constant
        SUB     BH,BL
        MOV     BL,BH           ; x is in BL
SAVE_Y:
        MOV     BH,0            ; Clear high byte
        MOV     Y_QUAD4,BX      ; Store x in memory
; At this point:
;    X_QUAD4 = x coordinate scaled to second quadrant
;    Y_QUAD4=  y coordinate scaled to second quadrant
; Set program's operation mode by installing new code word in
; the 8087 control register
; ROUND_DOWN =
;          17FFH  = 0 0 0 1 0 1 1 1 - 1 1 1 1 1 1 1 1
;                         _ ___ ___   _  ____________
;                         |  |   |    |  All exceptions masked
;                         |  |   |    |_ Interrupt masked
;                         |  |   |______ Precision = 64 bits
;                         |  |__________ Round down
;                         |_____________ Affine closure
;       FLDCW   ROUND_DOWN
;**********************|
; calculate hypotenuse |
;     using the 8087   |
;**********************|
        FILD    X_QUAD4         ;    x      |
        FMUL    ST,ST(0)        ;    x^2    |
        FILD    Y_QUAD4         ;    y      |    x^2   
        FMUL    ST,ST(0)        ;    y^2    |    x^2   
        FADD    ST,ST(1)        ; y^2 + x^2 |    x^2
        FSQRT                   ;Rt(y^2+x^2)|    x^2
        FISTP   DIST_2_EYE      ;    x^2    |
        FSTP    ST(0)           ;  EMPTY    |
; 8086 scaling of distance to bullseye
        MOV     AX,DIST_2_EYE   ; Distance to bullseye
        CMP     AX,10           ; Minimum score is 1
        JB      OK_TO_CALC      ; Go if less than 10
        MOV     DX,0            ; 0 score
        JMP     EXIT_SCORE
OK_TO_CALC:
        MOV     DX,10
        SUB     DX,AX
EXIT_SCORE:
        RET
SCORE_SHOT      ENDP
;******************************************************************
;
SCOPE_ON        PROC    NEAR
; Display target graphics with last shot fired
;
; Erase target area
        CALL    DATA_NORMAL
;**********************|
; clear display area   |
;**********************|
        MOV     CH,0            ; Start column
        MOV     CL,8            ; Start row
        MOV     DH,22           ; Horizontal bytes
        MOV     DL,21           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
;
        FLDCW   ROUND_EVEN
;**********************|
; clear display area   |
;**********************|
        MOV     CH,0            ; Start column
        MOV     CL,8            ; Start row
        MOV     DH,22           ; Horizontal bytes
        MOV     DL,21           ; Vertical bytes
        MOV     AL,00000111B    ; Color = gray
        CALL    COARSE_FILL
;------------------|
;   red circles    |
;------------------|
        LEA     SI,CIRCLE_IMAGE
        CALL    SHOW_TIFF
;**********************|
;    display digits    |
;**********************|
        LEA     SI,DIGITS1      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS2      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS3      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS4      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS5      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS6      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS7      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS8      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS9      ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS10     ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS11     ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS12     ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
        LEA     SI,DIGITS13     ; Text with target digits
        LEA     DI,FONT_1X8
        CALL    FINE_TEXT
;
;**********************|
;    score shot        |
;**********************|
; Scoring coordinates in the variables CS:X_VALUE and CS:Y_VALUE
; First test for missed shot
        CMP     CS:HIT_SW,1             ; Shot hit?
        JE      PLOT_SCORE      ; Go if hit
        CALL    DATA_XOR        ; Reenamble XOR mode
        RET                     ; Exit if not a hit
PLOT_SCORE:
        CALL    GET_SCORE
        MOV     AL,CS:X_VALUE   ; Byte offset on the x axis
        MOV     BL,8            ; Number of pixels per byte
        MUL     BL              ; Multiply
; AX holds x axis offset
        ADD     CS:SHOT_X,AX    ; Locate x coordinate of bit map
; Plot y coordinate
        MOV     AL,CS:Y_VALUE   ; Byte offset on the y axis
        MOV     BL,8            ; Number of pixels per byte
        MUL     BL              ; Multiply
; AX holds y axis offset
        ADD     CS:SHOT_Y,AX    ; Locate x coordinate of bit map
; Display shot hole
        LEA     SI,CS:SHOT_X    ; Offset of display block
        LEA     BX,CS:SHOT_COLOR
        CALL    VARI_MAP        ; Display routine
; Restore original coordinates
        MOV     CS:SHOT_X,7
        MOV     CS:SHOT_Y,70
        CALL    DATA_XOR
        RET
SCOPE_ON        ENDP
;******************************************************************
;
MOVE_CX_DIGS    PROC    NEAR
; Auxiliary procedure to move a given number of digits into a buffer
; On entry:
;         SI --> source holding digits
;         DI --> destination for digits
;         CX = number of digits to move
; Note: a block move is not convenient because ES is used as a video
;       buffer pointer
MOVE_DIGITS:
        MOV     AL,[SI]         ; Get source digit
        MOV     [DI],AL         ; Place in destination
        INC     SI              ; Bump buffer pointers
        INC     DI
        LOOP    MOVE_DIGITS
        RET
MOVE_CX_DIGS    ENDP
;*******************************************************************
;
MOUSE_MOVE      PROC    NEAR
; The following procedure calls service number 11 of the mouse
; interrupt to detect horizontal or vertical movement. The display
; of the crosshair symbol is handled by the program routine named
; MOVE_CURSOR
        MOV     AX,11           ; Service request to read counters
        INT     33H             ; Mouse interrupt
; CX = Horizontal mouse movement from last call to this service
; DX = vertical mouse movement from last call
        MOV     AL,CL           ; Horizontal counter to AL
        MOV     AH,DL           ; Vertical counter to AH
        CMP     AX,0            ; If AX is 0 then no mouse movement
        JNE     MOUSE_DRAGED    ; Go if mouse moved
        RET                     ; Go if no movement
MOUSE_DRAGED:
        CALL    MOVE_CURSOR     ; Update cursor position
        RET
MOUSE_MOVE      ENDP
;*****************************************************************
;
TEST_4_KEY      PROC    NEAR
; Test for user pressing the <Esc> key and exit directly
; Test for <F1> key and toggle scope
        CALL    KBR_STATUS      ; Carry set if keystroke ready
        JC      READ_KEY        ; Get keystroke
NOT_KEY:
        RET                     ; Return if no keystroke
;**********************|
;     get keystroke    |
;**********************|
READ_KEY:
        CALL    KBR_WAIT        ; Get keystroke in buffer
        CMP     AX,011BH        ; Test for <Esc> key
        JNE     NOT_ESC         ; Illegal keystroke
; <Esc> key pressed. Go to exit routine directy
        POP     AX              ; Adjust stack
; Reset scoreboard variables, except the match count
        MOV     RUN_CNT,0
        MOV     THIS_CNT,0
        MOV     WORD PTR SCORE_CNT,0
        JMP     BOAR_MATCH_EXIT
; Test for <F1> key
NOT_ESC:
        CMP     AX,3B00H        ; Test for <F1> key
        JNE     NOT_KEY         ; Illegal keystroke
; <F1> key pressed. Toggle scope ON/OFF according to SCOPE_SW
        CMP     SCOPE_SW,1      ; Test for scope ON
        JE      TURN_OFF        ; Turn off scope
        MOV     SCOPE_SW,1      ; Set switch
        CALL    SCOPE_ON        ; Turn scope on
        RET
TURN_OFF:
        MOV     SCOPE_SW,0      ; Change switch
        CALL    SCOPE_OFF       ; Call procedure
        RET
TEST_4_KEY      ENDP
;****************************************************************
;
FLUSH_MOUSE     PROC    NEAR
; Flush mouse right button
; Use mouse service number 5 to test for right button pressed
; Carry set if button was pressed
FLUSH_IT:
        MOV     AX,5            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button presses
        CMP     BX,0            ; Test for no press
        JNE     FLUSH_IT        ; Go if pressed
        RET
FLUSH_MOUSE     ENDP
;*****************************************************************
;
TEST_4_LOAD     PROC    NEAR
; Now get new press
        MOV     AX,5            ; Service request number
        MOV     BX,1            ; Report right button
        INT     33H             ; Mouse interrupt
; BX returns the number of button presses
        CMP     BX,0            ; Test for no press
        JNE     RIGHT_BUT_ON    ; Go if pressed
        CLC                     ; Return flag
        RET
RIGHT_BUT_ON:
        MOV     CS:GUN_LOADED,1 ; Gun loaded switch
        STC                     ; Carry set
        RET
TEST_4_LOAD     ENDP
;
;****************************************************************
RUN_DELAY       PROC    NEAR
; Delay for 2 second while monitoring mouse movement
        MOV     AH,0            ; Service request number
        INT     1AH             ; Read system time interrupt
; DX holds the low word of the time count
        MOV     TIMER_COUNT,DX  ; Store count in variable
; Check for cursor movement
DELAY_ENTRY:
        CALL    MOUSE_MOVE      ; Local procedure
; Check timer count
        MOV     AH,0            ; Service request number
        INT     1AH             ; Read system time interrupt
; DX holds the low word of the time count
        MOV     BX,TIMER_COUNT  ; Old count to BX
        CMP     BX,DX           ; Compare with present count
        JG      ADJUST_COUNT    ; Adjust if present value is
                                ; greater than previous one
        SUB     DX,BX           ; Calculate timer beats
        JMP     DO_TIME         ; and go to calculations
ADJUST_COUNT:
        MOV     CX,0FFFFH       ; Lasgest value to CX
        SUB     CX,BX           ; Subtract previous count
        ADD     CX,DX           ; Add-in present count
        MOV     DX,CX           ; Move to DX
DO_TIME:
; DX holds number of time beats elapsed (rate is 18.2 beats
; per second
        CMP     DX,37           ; 2 second delay
        JA      END_DELAY       ; Go if greater than 37 beats
        JMP     DELAY_ENTRY     ; Continue if not
END_DELAY:
        RET
RUN_DELAY       ENDP
;
;*****************************************************************
SHOW_STATUS     PROC    NEAR
; Display status line text according to the following variables
; COM_SW
;          = 0 for LOAD
;            1 for FIRE WHEN READY
;            2 for CEASE FIRING
; RUN_SW
;          = 0 for PRACTICE
;            1 for MATCH
; FS_SW
;          = 0 for SLOW
;          = 1 for FAST
;
        CALL    DATA_NORMAL
;
; Draw bottom 10 text lines of green status area
        MOV     CH,00           ; Start column
        MOV     CL,34           ; Start row
        MOV     DH,39           ; Horizontal bytes
        MOV     DL,10           ; Vertical bytes
        MOV     AL,00000010B    ; Green
        CALL    COARSE_FILL
;
        LEA     SI,STAT_MS      ; Status area text
        LEA     DI,FONT_1X16
        CALL    MULTI_TEXT      ; displayed at screen top right
;
        LEA     SI,COM0_LN      ; Pointer to command message text
        CMP     COM_SW,0        ; Does switch match message ?
        JE      SHOW_COMLN      ; Display if it does
        LEA     SI,COM1_LN      ; Change to next message
        CMP     COM_SW,1        ; Does switch match ?
        JE      SHOW_COMLN      ; Display message if match
        LEA     SI,COM2_LN      ; Set new message
        JMP     SHOW_SPEEDLN    ; Post CEASE FIRING message only
SHOW_COMLN:
        LEA     DI,FONT_1X16
        CALL    FINE_TEXT       ; Display procedure
;
        LEA     SI,RUN0_LN      ; Pointer to run type message
        CMP     RUN_SW,0        ; Does switch match message ?
        JE      SHOW_RUNLN      ; Display if it does
        LEA     SI,RUN1_LN      ; Change to next message
SHOW_RUNLN:
        LEA     DI,FONT_1X16
        CALL    FINE_TEXT       ; Display procedure
;
        LEA     SI,SPEED0_LN    ; Pointer to run speed message
        CMP     SPEED_SW,0      ; Does switch match message ?
        JE      SHOW_SPEEDLN    ; Display if it does
        LEA     SI,SPEED1_LN    ; Change to next message
SHOW_SPEEDLN:
        LEA     DI,FONT_1X16
        CALL    FINE_TEXT       ; Display procedure
;
        CALL    DATA_XOR
        RET
SHOW_STATUS     ENDP
;*****************************************************************
;
VARI_MAP        PROC    NEAR
; Display an encoded graphic block using a single color code
; On entry:
;      CS:SI --> Start of control area of graphic block to be
;                displayed
;      CS:BX --> byte holding the color code
;
; Register set-up:
;               AH = bit map to be displayed (from CS:[SI])
;               AL = color code
;               BL = number of rows in block
;               BH = number of bytes per row (dynamic counter)
;               CX = x coordinate of block start
;               DX = y coordinate of block start
;               DI --> start of encoded graphic block
; Memory:
;            CS:COUNT_8 ........ Counter for 8 bits
;            CS:BYTES .......... Number of bytes in block
;                                (used to re-load BH)
;
; Initialize registers
        MOV     AL,BYTE PTR CS:[BX]     ; Color code to AL
        MOV     CX,WORD PTR CS:[SI]     ; x coordinate
        MOV     CS:X_COORD,CX           ; Store in variable
        ADD     SI,2                    ; Bump pointer
        MOV     DX,WORD PTR CS:[SI]     ; y coordinate
        ADD     SI,2                    ; Bump pointer
        MOV     BL,BYTE PTR CS:[SI]     ; Number of rows
        INC     SI                      ; Bump pointer
        MOV     BH,BYTE PTR CS:[SI]     ; Bytes per block
        MOV     CS:BYTES,BH             ; Store in variable
        INC     SI                      ; Bump pointer
        XCHG    SI,DI           ; Buffer start to DI
        MOV     CS:COUNT_8,8    ; Prime bit counter
DISPLAY_BYTE1:
        MOV     AH,CS:[DI]      ; Bit map to AH
        CMP     AH,0H           ; Test for empty byte
        JNZ     TEST_BIT1
; Byte is all zeros
        ADD     CX,8            ; Add 8 to x coordinte
        JMP     NEXT_BYTE1
TEST_BIT1:
        TEST    AH,10000000B    ; Is high bit set?
        JZ      NEXT_BIT1       ; Bit not set
; Set the pixel
        PUSH    AX              ; Save entry registers
        PUSH    BX
;
; Address computation from x and y pixel coordinates 
; On entry: 
;               CX = x coordinate of pixel (range 0 to 639) 
;               DX = y coordinate of pixel (range 0 to 479) 
; On exit:
;               BX = byte offset into video buffer 
;               AH = bit mask for the write operation using
;                    VGA write modes 0 or 2
;               AL is preserved
; Save all entry registers 
        PUSH    CX 
        PUSH    DX 
; Compute address
        PUSH    AX          ; Save accumulator 
        PUSH    CX          ; Save x coordinate 
        MOV     AX,DX       ; y coordinate to AX 
        MOV     CX,80       ; Multiplier (80 bytes per row)
        MUL     CX          ; AX = y times 80 
        MOV     BX,AX       ; Free AX and hold in BX 
        POP     AX          ; x coordinate from stack 
; Prepare for division 
        MOV     CL,8        ; Divisor
        DIV     CL          ; AX / CL = quotient in AL and 
                            ; remainder in AH 
; Add in quotient 
        MOV     CL,AH       ; Save remainder in CL 
        MOV     AH,0        ; Clear high byte 
        ADD     BX,AX       ; Offset into buffer to BX 
        POP     AX          ; Restore AX
; Compute bit mask from remainder 
        MOV     AH,10000000B    ; Unit mask for 0 remainder 
        SHR     AH,CL       ; Shift right CL times 
;
; VGA mode number 18 device driver for writing an individual
; pixel or a pixel pattern to the graphics screen
;
; On entry:
;               BX = byte offset into the video buffer
;               AL = pixel color in IRGB format
;               AH = bit pattern to set
;
        PUSH    AX              ; Color byte
        PUSH    AX              ; Twice
; Set Bit Mask Register according to mask in AH
        MOV     DX,3CEH     ; Graphic controller latch
        MOV     AL,8
        OUT     DX,AL       ; Select data register 8
        JMP     SHORT $+2
        INC     DX          ; To 3CFH
        POP     AX          ; AX once from stack
        MOV     AL,AH       ; Bit pattern
        OUT     DX,AL       ; Load bit mask
        JMP     SHORT $+2
; Write color code
        MOV     AL,ES:[BX]  ; Dummy read to load latch
                            ; registers
        POP     AX          ; Restore color code
        MOV     ES:[BX],AL  ; Write the pixel with the
                            ; color code in AL
; Restore all entry registers 
        POP     DX 
        POP     CX 
;
;
        POP     BX              ; Restore registers
        POP     AX
NEXT_BIT1:
        SAL     AH,1            ; Shift AH to test next bit
        INC     CX              ; Bump x coordinate counter
        DEC     CS:COUNT_8      ; Bit counter
        JZ      NEXT_BYTE1      ; Exit if counter rewound
        JMP     TEST_BIT1       ; Continue
; Index to next byte in row, if not at end of row
NEXT_BYTE1:
        DEC     BH              ; Bytes per row counter
        JZ      NEXT_ROW1       ; End of graphic row
BYTE_ENTRY1:
        INC     DI              ; Bump graphic code pointer
        MOV     CS:COUNT_8,8    ; Reset bits counter
        JMP     DISPLAY_BYTE1
; Index to next row
NEXT_ROW1:
; Test for last graphic row
        DEC     BL              ; Row counter
        JZ      GRAPH_END1      ; Done, exit
        MOV     BH,CS:BYTES     ; Reset bytes counter
        INC     DX              ; Bump y coordinate control
        MOV     CX,CS:X_COORD   ; Reset x coordinate control
        JMP     BYTE_ENTRY1
GRAPH_END1:
        RET
VARI_MAP        ENDP
;
;*****************************************************************
;
PIXEL_WRITE     PROC    NEAR
; This auxiliary procedures saves and restores the registers
; used by the PIXEL_ADD and WRITE_PIX routines
        PUSH    AX          ; Save entry registers
        PUSH    BX
        CALL    PIXEL_ADD
        CALL    WRITE_PIX
        POP     BX          ; Restore registers
        POP     AX
        RET
PIXEL_WRITE     ENDP
;
;*******************************************************************
;                         code segment data                         
;*******************************************************************
;****************************|
;     shot hole bit map      |
;****************************|
; Block control area:                      Displacement -->
SHOT_X  DW      7           ; Present x coordinate         0
SHOT_Y  DW      70          ; y coordinate                 2
        DB      6           ; Horizontal rows in block     4
        DB      1           ; Number of bytes per row      5
;
; Symbol encoding for shot hole
        DB      000H
        DB      000H
        DB      018H
        DB      03CH
        DB      03CH
        DB      018H
        DW      0
;
SHOT_COLOR      DB      00000000B
;
CODE_1  ENDS
        END

  DB      03CH
        DB      018H
        DW      0
;
SHOT_COLOR      DB      00000000